/*
 * Copyright(c)  2012       Rijkswaterstaat DVS
 *
 * File:                    CRAPTAB.C
 *
 * Nummer kruispunt:        1
 * Regelprogramma vri:      ... - ...
 *
 * Wegbeheerder:            ...
 *                          ...
 *
 * Programmeur:             ...
 *
 * Versie RWS-C:            1.1
 *
 * Versiebeheer:
 * - versie:                1.0
 * - datum:                 ...
 * - toelichting:           ...
 *
 * Wijzigingen:
 * - versie:                ...
 * - datum:                 ...
 * - toelichting:           ...
 *
 */

#include "crtypes.h"
#include "crapcod.h"
#include "craptab.h"
#include "ccie_int.h"
#include "crapdef.h"

/* 
 * =============================================================
 * declaraties t.b.v. het blokkenschema
 * =============================================================
 */

/*     BLOKKEN schema                                           */
struct BLOKKEN  BLOKKEN_tabel[] = {
/*     blok:    sg:     toewijzing:                             */
/*     BKl,     SGn,    PRIM + ALT,                             */
       STOP};

/*     Wachtblok                                                */
struct WB  WB_tabel[] = {
/*     wachtblok:                                               */
/*     BKl,                                                     */
       STOP};

/*
 * =============================================================
 * wachtstandrichtingen
 * =============================================================
 */

/*     Wachtstandrichtingen               */
struct WS_R  WSGR_tabel[] = {
/*     wachtstandrichting                 */
/*     SGn,                               */
       STOP};

/* 
 * =============================================================
 * matrices
 * =============================================================
 */

/*     CONFLICT- en (garantie)ontruimingstijden matrix          */
struct CONFLICT  CONFLICT_tabel[] = {
/*                                    instellingen              */
/*                                    van de tijden:            */
/*     sg:       conflicterende sg:   GO_TIJD:  O_TIJD:         */
/*     SGn,      SGj,                 x.y,      x.y,            */
       STOP};

/*     FICTief CONFLICT matrix                                  */
struct FICT_CONFLICT  FICT_CONFLICT_tabel[] = {
/*     sg:            fictief conflicterende sg:                */
/*     SGn,           SGj,                                      */
       STOP};

/*     extra op te geven SG'en k volgens BS_H5 formule t        */
struct SG_BS_H5t   SG_BS_H5t_tabel[] = {
/*     sg:         sg k volgens BS_H5 formule t:                */
/*     SGn,        SGk,                                         */
       STOP};

/*     extra op te geven SG'en j volgens BS_H5 formule ac       */
struct SG_BS_H5ac  SG_BS_H5ac_tabel[] = {
/*     sg:         sg k volgens BS_H5 formule ac:               */
/*     SGn,        SGk,                                         */
       STOP};

/*     gekoppelde signaalgroepen volgens BS_H6.6                */
struct SG_BS_H66  SG_BS_H66_tabel[] = {
/*     sg:        gekoppelde sg:                                */
/*     SGn,       SGj,                                          */
       STOP};

/* 
 * =============================================================
 * declaraties t.b.v. de signaalgroepprocedure 
 * =============================================================
 */

/*     SignaalGroep_TIJDEN tabel                                */
struct SG_TIJDEN        SG_TIJDEN_tabel[] = {
/*            instellingen van de tijden:                       */
/*     sg:    GG_TIJD:  VG_TIJD:  GGL_TIJD:  GL_TIJD:  GR_TIJD: */
/*     SGn,    x.y,      x.y,      x.y,       x.y,      x.y,    */
       STOP};  

/*     MG_TIJDEN tabel                                          */
struct MG_TIJDEN        MG_TIJDEN_tabel[] = {
/*            instellingen (x.y of NG) van de tijden:           */
/*     sg:    MG_TIJD:  MG_TIJD1:  MG_TIJD2:  MG_TIJD3:         */
/*     SGn,    x.y,      x.y,       x.y,       x.y,             */
       STOP};            

/*     Extra MG_TIJDEN tabel                                    */
struct E_MG_TIJDEN       E_MG_TIJDEN_tabel[] = {
/*            instellingen (x.y of NG) van de tijden:           */
/*     sg:    MG_TIJD4:  MG_TIJD5:  MG_TIJD6:                   */
/*     SGn,    x.y,       x.y,       x.y,                       */
       STOP};

/*     Extra2 MG_TIJDEN tabel                                   */
struct E_MG_TIJDEN       E2_MG_TIJDEN_tabel[] = {
/*            instellingen (x.y of NG) van de tijden:           */
/*     sg:    MG_TIJD7:  MG_TIJD8:  MG_TIJD9:                   */
/*     SGn,    x.y,       x.y,       x.y,                       */
       STOP};

/*     Extra3 MG_TIJDEN tabel                                   */
struct E_MG_TIJDEN       E3_MG_TIJDEN_tabel[] = {
/*            instellingen (x.y of NG) van de tijden:           */
/*     sg:    MG_TIJD10: MG_TIJD11: MG_TIJD12:                  */
/*     SGn,    x.y,       x.y,       x.y,                       */
       STOP};

/*     SignaalGroep-DETECTIE tabel                              */
struct SG_DETECTIE           SG_DETECTIE_tabel[] = {
/*     D():     type:        sg:     bzttijd: hiaattijd: extra_hiaattijd: toewijzing:                */
/*     SGn_i,   DP (of DK),  SGn,    x.y,       x.y,       x.y,           AVR + BS_H5p + H1e + H2e,  */
       STOP};

/*     tabel voor SG'en met RichtingGevoelige Aanvraag          */
struct SG_RGA     SG_RGA_tabel[] = {
/*     1e D():    2e D():  koplus:      sg:   paarnr:           */
/*     SGn_i,     SGn_j,   SGn_k,       SGn,       x,           */
       STOP};

/*     FIETS- of VOETGangersRichting tabel                      */
struct FIETS_VOETG_R  FIETS_VOETG_R_tabel[] = {
/*     fiets- of voetgangersrichting:                           */
/*     SGn,                                                     */
       STOP};

/* 
 * =============================================================
 * declaraties t.b.v. standaardapplicaties
 * =============================================================
 */

/*     tabel voor SG'en die gebruik maken van PPAH en VNMH      */
struct SG_PPAH  SG_PPAH_tabel[] = {
/*     PPAH() (en VNMH()):  TIJD():                             */
/*     SGn,                 SGn_i,                              */
       STOP};

/* 
 * =============================================================
 * tijden, klokken en schakelaars
 * =============================================================
 */

/*     TIJDEN tabel                                             */
struct TIJDEN           TIJDEN_tabel[] = {
/*     TIJD():          instelling:                             */
/*     SGn_i,            x.y,                                   */
       STOP};

/*     KLOKKEN tabel                                            */
struct KLOKKEN KLOKKEN_tabel[] = {
/*     KL():           1e tijdstip:  2e tijdstip:               */
/*     NAAM,            x.yz,         x.yz,                     */
       STOP};

/*     SCHAKELAAR tabel                                         */
struct SCHAKELAAR SCHAKELAAR_tabel[] = {
/*     SCH():                instelling:                        */
/*     NAAM,                 AAN (of UIT),                      */
       STOP};

/* 
 * ===============================================================
 * Extra parameters
 * ===============================================================
 */

/*     extra EGGPARMS tabel  */
struct EGGPARMS       EGGPARMS_tabel[] = {
/*     EGGPARM(),     instelling    */
       STOP};

/*     extra PARMS tabel  */
struct EPARMS       EPARMS_tabel[] = {
/*     EPARM(),     instelling    */
       STOP};

/* 
 * =============================================================
 * OPTIES
 * =============================================================
 */

/* 
 * =============================================================
 * optie voor het vasthouden van de blokactiviteit
 * =============================================================
 */

/*     BK gebonden optie: BO_OP(BKl)                            */
struct BK_OPTIE           BO_OP_tabel[] = {
/*     optie voor blok:   inhoud van de optie:                  */
/*     BKl,               functie,                              */
       STOP};

/* 
 * =============================================================
 * opties voor aanvragen, meeverlengen en tegenhouden
 * =============================================================
 */

/*     SG gebonden optie: MA_OP(SGn)                            */
struct SG_OPTIE           MA_OP_tabel[] = {
/*     optie voor sg:     inhoud van de optie:                  */
/*     SGn,               functie,                              */
       STOP};

/*     SG en BK gebonden optie:    PPP_OP(SGn, BKl)             */
struct SG_BK_OPTIE                 PPP_OP_tabel[] = {
/*     optie voor sg:  voor blok:  inhoud van de optie:         */
/*     SGn,            BKl,        functie,                     */
       STOP};

/*     SG gebonden optie: TMVG_OP(SGn)                           */
struct SG_OPTIE           TMVG_OP_tabel[] = {
/*     optie voor sg:     inhoud van de optie:                   */
/*     SGn,               WAAR (of functie),                     */
       STOP};

/*     SG gebonden optie: TR_OP(SGn)                            */
struct SG_OPTIE           TR_OP_tabel[] = {
/*     optie voor sg:     inhoud van de optie:                  */
/*     SGn,               functie,                              */
       STOP};

/* 
 * =============================================================
 * opties voor versnelde realisatie  
 * =============================================================
 */

/*     SG gebonden optie: VAA_OP(SGn)                           */
struct SG_OPTIE           VAA_OP_tabel[] = {
/*     optie voor sg:     inhoud van de optie:                  */
/*     SGn,               WAAR (of functie),                    */
       STOP};


/*     SG gebonden optie: PPV_OP(SGn)                           */
struct SG_OPTIE           PPV_OP_tabel[] = {
/*     optie voor sg:     inhoud van de optie:                  */
/*     SGn,               WAAR (of functie),                    */
       STOP};

/* 
 * =============================================================
 * optie voor bijzondere realisatie  
 * =============================================================
 */

/*     SG gebonden optie: PPB_OP(SGn)                           */
struct SG_OPTIE           PPB_OP_tabel[] = {
/*     optie voor sg:     inhoud van de optie:                  */
/*     SGn,               functie,                              */
       STOP};

/* 
 * =============================================================
 * optie voor speciale realisatie  
 * =============================================================
 */

/*     SG gebonden optie: PPS_OP(SGn)                           */
struct SG_OPTIE           PPS_OP_tabel[] = {
/*     optie voor sg:     inhoud van de optie:                  */
/*     SGn,               functie,                              */
       STOP};

/* 
 * =============================================================
 * opties voor alternatieve realisatie  
 * =============================================================
 */

/*     SG en BK gebonden optie:    PPA_OP(SGn, BKl)             */
struct SG_BK_OPTIE                 PPA_OP_tabel[] = {
/*     optie voor sg:  voor blok:  inhoud van de optie:         */
/*     SGn,            BKl,        functie,                     */
       STOP};

/*     SG en BK gebonden optie:    VNM_OP(SGn, BKl)             */
struct SG_BK_OPTIE                 VNM_OP_tabel[] = {
/*     optie voor sg:  voor blok:  inhoud van de optie:         */
/*     SGn,            BKl,        functie,                     */
       STOP};

/* 
 * =============================================================
 * opties voor beinvloeding van het verloop van de signaalgroep
 * =============================================================
 */

/*     SG gebonden optie: AFK_OP(SGn)                           */
struct SG_OPTIE           AFK_OP_tabel[] = {
/*     optie voor sg:     inhoud van de optie:                  */
/*     SGn,               functie,                              */
       STOP};

/*     SG gebonden optie: BL_OP(SGn)                            */
struct SG_OPTIE           BL_OP_tabel[] = {
/*     optie voor sg:     inhoud van de optie:                  */
/*     SGn,               functie,                              */
       STOP};

/*     SG gebonden optie: RWR_OP(SGn)                           */
struct SG_OPTIE           RWR_OP_tabel[] = {
/*     optie voor sg:     inhoud van de optie:                  */
/*     SGn,               functie,                              */
       STOP};

/*     SG gebonden optie: VRVG_OP(SGn)                          */
struct SG_OPTIE           VRVG_OP_tabel[] = {
/*     optie voor sg:     inhoud van de optie:                  */
/*     SGn,               functie,                              */
       STOP};

/*     SG gebonden optie: VVAG2e_OP(SGn)                        */
struct SG_OPTIE           VVAG2e_OP_tabel[] = {
/*     optie voor sg:     inhoud van de optie:                  */
/*     SGn,               functie,                              */
       STOP};

/*     SG gebonden optie: RVAG2e_OP(SGn)                        */
struct SG_OPTIE           RVAG2e_OP_tabel[] = {
/*     optie voor sg:     inhoud van de optie:                  */
/*     SGn,               functie,                              */
       STOP};

/*     SG gebonden optie: VMVG_OP(SGn)                          */
struct SG_OPTIE           VMVG_OP_tabel[] = {
/*     optie voor sg:     inhoud van de optie:                  */
/*     SGn,               functie,                              */
       STOP};

/* 
 * =============================================================
 * tabel met koppelsignalen
 * =============================================================
 */

/*     KOPPEL tabel                                             */
struct KOPPEL        KOPPEL_tabel[] = {
/*     hulpfunctie:  ingangssignaal:   uitgangssignaal:   KSU of KSH:         */
/*     NAAM,         x (of GEEN),      x (of GEEN),       KSU, KSH (of GEEN)  */
       STOP};

/*
 * ================================================================
 * tabel met gekoppelde regelingen
 * ================================================================
 */

/*     REGELING tabel                                           */
struct REGELING   REGELING_tabel[] = {
/*     Nummer,  */
       STOP};
