#ifndef CRFPBRT_H
#define CRFPBRT_H

/*************************************************************************
*  Program Name  : FLASH (FLexit Application SHell)                      *
*========================================================================*
*                                                                        *
*  Filename      : crfpbrt.h                                             *
*                                                                        *
*  Function      : C-regelaar FLASH procesbesturing functions.           *
*                                                                        *
*  Date Created  : April 11, 1996                                        *
*                                                                        *
*  Version       : 1.0                                                   *
*                                                                        *
*  Author(s)     : E.E. de Vries (Ed)                                    *
*                                                                        *
*  Files used    :                                                       *
*                                                                        *
*  Date Modified : See RCS identification                                *
*                                                                        *
*  Modifications : pb ver 6: Sept. 28, 2000 F. Peters - Goudappel Coffeng*
*                  Maximize size of printxy window to 50x80 from 25x120  *
*                  pb ver 7: Aug. 2001  F. Peters - Goudappel Coffeng    *
*                  Toevoeging van TDI regelaar (toeritdoseerinstallatie) *
*                                                                        *
*  Comments      :                                                       *
*                                                                        *
*------------------------------------------------------------------------*
*  COPYRIGHT (c) 1996 by A.N.D. Identification B.V. Rotterdam.           *
*************************************************************************/

/*----------------------------------------------------------------------*/
/* CONSTANT DEFINITIONS                                                 */
/*----------------------------------------------------------------------*/

#define KPRNR         CIF_WUS[CIF_AANT_US_FC+OVERIGE_SIGNALEN]
#define KOPPELNR(N)   CIF_WUS[CIF_AANT_US_FC+OVERIGE_SIGNALEN+(N)]

#define PROT_MIN_LEN     3              /* Min. protocol message length */
#define PROT_MAX_LEN     10             /* Max. protocol message length */

#define OFFSET   (2*CIF_AANT_IS_D + OVERIGE_SIGNALEN + MAX_KOPPELSGN)

#define MSG_TEXT_LEN     512       /* The max. length of a message text */

/* PrintXY Definitions */
/* ------------------- */
#define PRINTXY_CLASS  "printxyClass"       /* The printxy window class */
#define PRINTXY_TITLE  "C-Regelaar %d Opmerkingen" /* The printxy window title */
#define PRINTXY_LINE_LEN   120  /* The number of characters per printxy screen */
#define PRINTXY_NOF_LINES   50        /* The height of a printxy screen */
#define PRINTXY_TEXT_LEN  1024              /* Max. printxy text length */

/* Profile Definitions */
/* ------------------- */
#define PRINTXY_PROF_NAME      "printxy.ini"    /* Name of profile file */
#define PRINTXY_PROFNAME_LEN   512   /* The max. length of profile name */
#define PRINTXY_PROFSECT_MAIN  "Hoofdvenster"    /* Main window section */
#define PRINTXY_PROFKEY_XPOS   "X-Positie"  /* X-coordinate profile key */
#define PRINTXY_PROFKEY_YPOS   "Y-Positie"  /* Y-coordinate profile key */
#define PRINTXY_PROFKEY_WIDTH  "Breedte"           /* Width profile key */
#define PRINTXY_PROFKEY_HEIGHT "Hoogte"           /* Height profile key */

#define PRINTXY_FACENAME     "Courier New"         /* Face name of font */

#define PRINTXY_XPOS        0  /* Default X-position of the main window */
#define PRINTXY_YPOS        0  /* Default Y-position of the main window */
#define PRINTXY_WIDTH     500       /* Default width of the main window */
#define PRINTXY_HEIGHT    400      /* Default height of the main window */
#define PRINTXY_MINWIDTH  125       /* Minimum width of the main window */
#define PRINTXY_MINHEIGHT 100      /* Minimum height of the main window */

#define PRINTXY_CHAR_WIDTH   12              /* Default character width */
#define PRINTXY_CHAR_HEIGHT  18             /* Default character height */


/* Conversion constants */
/* -------------------- */
#define MAX_BKI     RWS_AANT_BLOKKEN             /* Max. aantal blokken */
#define MAX_SGI     CIF_AANT_US_FC        /* Max. aantal signaalgroepen */
#define MAX_DTI     CIF_AANT_IS_D             /* Max. aantal detectoren */

#define MAX_BKN         10                       /* Max. aantal blokken */
#define MAX_SGN        100                /* Max. aantal signaalgroepen */
#define MAX_DTN         20                    /* Max. aantal detectoren */


/* Regelaar modi */
/* ------------- */
#define CRM_INIT       0                       /* Initialiseer regelaar */
#define CRM_REGELEN    1                            /* Regel een rondje */
#define CRM_EXIT       5                          /* Beeindigen regelen */
#define CRM_HALTEER    8                                /* Halteer mode */
#define CRM_FIXEER     9                             /* Fixeer regelaar */
#define CRM_HERINIT   10                   /* Her-initialiseer regelaar */

/* Macro commando codes */
/* -------------------- */
#define STOP            0x00
#define MODIFICEREN     0X20
#define CONTINUE        0X40
#define EENMALIG        0X60

/* Macro definitie bestand codes */
/* ----------------------------- */
#ifndef _HULP
 #define _HULP
 #define        KOP_CODE                (0X00<<5)  /* gekoppelde elementen */
 #define        HF_CODE                 (0X01<<5)  /* hulpfuncties, eenmalig */
 #define        HF_SG_CODE              (0X02<<5)  /* hulpfuncties per signaalgroep */
 #define        OP_SG_CODE              (0X03<<5)  /* opties per signaalgroep */
 #define        HF_BK_CODE              (0X04<<5)  /* hulpfuncties per blok */
 #define        OP_BK_CODE              (0X05<<5)  /* opties per signaalgroep per blok */
 #define        HF_SG_BK_CODE           (0X06<<5)  /* hulpfuncties per signaalgroep per blok */
 #define        OP_SG_BK_CODE           (0X07<<5)  /* opties per signaalgroep per blok */
 #define        TT_SG_CODE              (0X08<<5)  /* toestanden per signaalgroep */
 #define        TD_SG_LP_CODE           (0X09<<5)  /* tijden per sig groep, lopend of niet */
 #define        TD_SG_WD_CODE           (0X0A<<5)  /* tijden per sig groep, de waarde */
 #define        TD_TD_SG_LP_CODE        (0X0B<<5)  /* tijden tussen sig groepen, lopend of niet */
 #define        TD_TD_SG_WD_CODE        (0X0C<<5)  /* tijden tussen sig groepen, de waarde */
 #define        UD_LP_CODE              (0X0D<<5)  /* user-defined variabelen, lopend of niet */
 #define        UD_WD_CODE              (0X0E<<5)  /* user-defined variabelen, de waarde */
 #define        TL_CODE                 (0X0F<<5)  /* Teller functies, eenmalig */
#endif

/* Message decoding codes */
/* ---------------------- */
#define         START_BYTE              0x80
#define         VERVOLG_BYTE            0x40
#define         LENGTE_MASK             0x10
#define         WAARDE_MASK             0x20
#define         MODE_MASK               0x60

#ifndef _6_BITS_MAX
#define         _4_BITS_MAX             0xF
#define         _6_BITS_MAX             0x3Ful /* ed#01 see header of DEBUG.C */
#define         _8_BITS_MAX             0xFF

#define         _4_bits_waarde(c)       (c&_4_BITS_MAX)
#define         _6_bits_waarde(c)       (c&_6_BITS_MAX)

#define         _4_msb(c)               (c&0x1E0)
#define         _5_lsb(c)               (c&0x1F)

#define         WAARDE_BIT              0x20
#define         LENGTE_BIT              0x10

#define         _0_BYTE_MAX             1
#define         _1_BYTE_MAX             _6_BITS_MAX
#define         _2_BYTE_MAX             ((_6_BITS_MAX+1)*(_1_BYTE_MAX+1)-1)
#define         _3_BYTE_MAX             ((_6_BITS_MAX+1)*(_2_BYTE_MAX+1)-1)
#define         _4_BYTE_MAX             ((_6_BITS_MAX+1)*(_3_BYTE_MAX+1)-1)
#define         _5_BYTE_MAX             ((_6_BITS_MAX+1)*(_4_BYTE_MAX+1)-1)
#endif

#define         geen_nieuw_bericht              (iber_lees==iber_schrijf)
#define         bericht_type(bericht)           (bericht[0]&MODE_MASK)
#define         extra_lengte_byte(bericht)      (bericht[0]&LENGTE_MASK)
#define         bepaal_functie(bericht, offset) ((((int)bericht[0]&0x0f)<<5)|((int)bericht[1+offset]&0x1f))
#define         bepaal_groepnr(bericht, offset) (_6_bits_waarde(bericht[2+offset]))
#define         bepaal_extra_lengte(bericht)    (_6_bits_waarde(bericht[1])+2)
#define         bepaal_norm_lengte(bericht)     (((bericht[0]&LENGTE_MASK)>>4)+2)
#define         bepaal_bool_waarde(bericht, offset) ((bericht[1+offset]&WAARDE_MASK)>>5)



/* -------------------------------------------------------------------- */
/* TYPE DEFINITIONS                                                     */
/* -------------------------------------------------------------------- */

typedef struct tagCRITEM
{
   int Function;                                     /* Function number */
   int Group;                                    /* Signal group number */
   int Block;                                           /* Block number */
   int Boolean;                                    /* Boolean item flag */
   int Value;                                             /* Item value */
} CRITEM;


/*----------------------------------------------------------------------*/
/* GLOBAL VARIABLES                                                     */
/*----------------------------------------------------------------------*/

extern char msgText[MSG_TEXT_LEN];                /* Global text buffer */

#ifdef LOG
extern FILE* logfile;                                /* Global log file */
#endif

enum aktie { INIT, INIT2, LEZEN, SCHRIJVEN };

/*----------------------------------------------------------------------*/
/* FUNCTION PROTOTYPES                                                  */
/*----------------------------------------------------------------------*/

/* msg.c */                                        /* Message functions */
/* ----- */
int   msgSend(mid_t To, st_t Time, cod_t Code, siz_t Size, void* Data);
void  msgDisplay(int Type, char* Text);
char* msgCompose(char* Text1, char* Text2, char* Text3);

/* conv.c */                           /* Det + Sg conversion functions */
/* ------ */
int  convInit(void);
void convExit(void);
int  convBkiToBkn(int Index);
int  convSgiToSgn(int Index);
int  convDtiToSgn(int Index);
int  convDtiToDtn(int Index);
int  convBknToBki(int Number);
int  convSgnToSgi(int Number);
int  convDtnToDti(int Sgn, int Dtn);

/* clock.c */                                        /* Clock functions */
/* ------- */
void clockUpdate(void);

/* creg.c */                                    /* C-regelaar functions */
/* ------ */
#ifndef NDEBUG
void cregAssert (char* FileName, int Line, int Expression);
#endif
void cregInit(HINSTANCE hInstance);
void cregReInit(void);
void cregExit(void);
void cregStatChanged(int Status);
void cregHalteerOne(void);
void cregEventHandler(mid_t From, mid_t To, st_t Time, cod_t Code, siz_t Size,
                      void* Data);
int  cregSetStatus(int Status);
void cregOnRevival(void);

/* det.c */                                       /* Detector functions */
/* ----- */
void detInit(void);
void detExit(void);
void detUpdate(void);
void detOnSetDtStat(siz_t Size, void* Data);

/* dsi.c */                                  /* Sel. detector functions */
/* ----- */
void dsiInit(void);
void dsiExit(void);

/* debug.c */                                     /* Debugger functions */
/* ------- */
void debugHandleInput(int Mode, CRITEM* Item);
void debugHandleOutput(void);

/* dump.c */                               /* Dump C-regelaar functions */
/* -------*/
int dumpCreate(char* FileName);

/* vlogfile.c */                                      /* VLOG functions */
/* -------*/
void vlogInit(void);
void vlogExit(void);
void vlogHandler(void);
void MaakVlogCfgFile(void);
int LeesCrapdefFile(char* crapdefFile);

/* error.c */
/* ------- */
void errorCheck(void);

/* koppel.c */                               /* Koppelsignaal functions */
/* -------- */
int  koppelInit(void);
int  koppelExit(void);
void koppelUpdateStatus(void);
void koppelUpdateInput(void);
void koppelUpdateOutput(void);
void koppelResendAll(void);

void koppelOnInit(mid_t From);
void koppelOnGetNofReg(siz_t Size, void* Data);
void koppelOnGetRegData(siz_t Size, void* Data);
void koppelOnEnableReg(mid_t From, int Enable);
void koppelOnEnableCom(int Enable, siz_t Size, void* Data);
void koppelOnSignal(siz_t Size, void* Data);

/* mtm.c */                                     /* MTM portal functions */
/* ----- */
void mtmInit(void);
void mtmExit(void);
void mtmUpdate(void);
void mtmSetMTM(siz_t Size, void* Data);

/* prot.c */                    /* CIE communication protocol functions */
/* ------ */
int protEncode(int Size, void* Data, int Mode, CRITEM* Item);
int protDecode(int Size, void* Data, int *Mode, CRITEM* Item);

/* sig.c */                                   /* Signaalgroep functions */
/* ----- */
void sigInit(void);
void sigExit(void);
void sigUpdateFc(int Force);
void sigOnSgFcExtern(void);
void sigOnSgFcIntern(void);
void sigResetTimingFlags(void);

/* stat.c */                                /* Program status functions */
/* ------ */
void statInit(void);
void statReInit(void);
void statExit(void);
int  statSet(int Status);
int  statGet(void);
int  statSetHalteer(int Status);
int  statUpdate(void);
void statChanged(void);

/* printxy.c */
/* --------- */
int printxyInit(HINSTANCE hInstance, int KprNr);
int printxyExit(void);
int toonesgInit(HINSTANCE hInstance, int KprNr);
int toonesgExit(void);


/*----------------------------------------------------------------------*/
/* MACRO FUNCTIONS                                                      */
/*----------------------------------------------------------------------*/

#ifndef NDEBUG
#undef assert
#define assert(E)   cregAssert((char*)(__FILE__), (int)(__LINE__), (int)(E))
#endif

#endif  /* CRFPBRT_H  */
