#ifndef CRAPCOD_H
#define CRAPCOD_H

/*
 * Copyright(c) 1992 RWS Dienst Verkeerkunde
 *
 * File         : crapcod.h
 *
 * Description  : RWS C-regelaar-macro-definities voor coderen van crapcod.c.
 *
 * History      : 15-03-90, Creation.
 *              : 04-10-90, Uitbreiding met prototypes voor
 *                datm, tijd, dag.
 *                6-7-92,  aanpassing aan nieuwe interface definitie
 *                         van de commissie C van de CVN
 *                29-09-94 wijziging WB
 *                02-11-94 toevoegen dump faciliteit
 */

#include "crtmo.h"
#include "crsgo.h"
#include "crbko.h"
#include "crdto.h"
#include "crhfo.h"

/* instructies en referenties */

#define         A(a)                     ( Hfs_val(__A,(a)))
#define         begin_A(a)               ( Hfs_begin(__A,(a)))
#define         einde_A(a)               ( Hfs_end(__A,(a)))
#define         set_A(a)                 ( Hfs_set(__A,(a)))
#define         reset_A(a)               ( Hfs_reset(__A,(a)))

#define         AFK(a)                   ( Hfs_val(__AFK,(a)))
#define         begin_AFK(a)             ( Hfs_begin(__AFK,(a)))
#define         einde_AFK(a)             ( Hfs_end(__AFK,(a)))
#define         set_AFK(a)               ( Hfs_set(__AFK,(a)))
#define         reset_AFK(a)             ( Hfs_reset(__AFK,a))

#define         AFK_OP(a)                ( Ops_val(__AFK_OP,a))
#define         begin_AFK_OP(a)          ( Ops_begin(__AFK_OP,a))
#define         einde_AFK_OP(a)          ( Ops_end(__AFK_OP,a))
#define         set_AFK_OP(a)            ( Ops_set(__AFK_OP,a))
#define         reset_AFK_OP(a)          ( Ops_reset(__AFK_OP,a))

#define         AR(a,b)                  ( Hfsb_val(__AR,a,b))
#define         begin_AR(a,b)            ( Hfsb_begin(__AR,a,b))
#define         einde_AR(a,b)            ( Hfsb_end(__AR,a,b))
#define         set_AR(a,b)              ( Hfsb_set(__AR,a,b))
#define         reset_AR(a,b)            ( Hfsb_reset(__AR,a,b))

#define         BA(a)                    ( Hfs_val(__BA,a))
#define         begin_BA(a)              ( Hfs_begin(__BA,a))
#define         einde_BA(a)              ( Hfs_end(__BA,a))
#define         set_BA(a)                ( Hfs_set(__BA,a))
#define         reset_BA(a)              ( Hfs_reset(__BA,a))

#define         BEURT(b)                 ( (Beurt_val(b)) ? TRUE:FALSE )
#define         begin_BEURT(b)           ( Beurt_begin(b))
#define         einde_BEURT(b)           ( Beurt_end(b))
#define         set_BEURT(b)             ( Beurt_set(b))
#define         reset_BEURT(b)           ( Beurt_reset(b))

#define         BLOK(b)                  ( Hfb_val(__BLOK,b))
#define         begin_BLOK(b)            ( Hfb_begin(__BLOK,b))
#define         einde_BLOK(b)            ( Hfb_end(__BLOK,b))
#define         set_BLOK(b)              ( Hfb_set(__BLOK,b))
#define         reset_BLOK(b)            ( Hfb_reset(__BLOK,b))

#define         BL(a)                    ( Hfs_val(__BL,a))
#define         begin_BL(a)              ( Hfs_begin(__BL,a))
#define         einde_BL(a)              ( Hfs_end(__BL,a))
#define         set_BL(a)                ( Hfs_set(__BL,a))
#define         reset_BL(a)              ( Hfs_reset(__BL,a))

#define         BL_OP(a)                 ( Ops_val(__BL_OP,a))
#define         begin_BL_OP(a)           ( Ops_begin(__BL_OP,a))
#define         einde_BL_OP(a)           ( Ops_end(__BL_OP,a))
#define         set_BL_OP(a)             ( Ops_set(__BL_OP,a))
#define         reset_BL_OP(a)           ( Ops_reset(__BL_OP,a))

#define         BO_OP(b)                 ( Opb_val(__BO_OP,b))
#define         begin_BO_OP(b)           ( Opb_begin(__BO_OP,b))
#define         einde_BO_OP(b)           ( Opb_end(__BO_OP,b))
#define         set_BO_OP(b)             ( Opb_set(__BO_OP,b))
#define         reset_BO_OP(b)           ( Opb_reset(__BO_OP,b))

#define         BR(a)                    ( Hfs_val(__BR,a))
#define         begin_BR(a)              ( Hfs_begin(__BR,a))
#define         einde_BR(a)              ( Hfs_end(__BR,a))
#define         set_BR(a)                ( Hfs_set(__BR,a))
#define         reset_BR(a)              ( Hfs_reset(__BR,a))

#define         D(c)                     ( Dt_val(c))
#define         begin_D(c)               ( Dt_begin(c))
#define         einde_D(c)               ( Dt_end(c))
#define         DFOUT(c)                 ( Dt_s_val(c))
#define         begin_DFOUT(c)           ( Dt_s_begin(c))
#define         einde_DFOUT(c)           ( Dt_s_end(c))
#define         DFOUT_OG(c)              ( Dt_og_val(c))
#define         begin_DFOUT_OG(c)        ( Dt_og_begin(c))
#define         einde_DFOUT_OG(c)        ( Dt_og_end(c))
#define         DFOUT_BG(c)              ( Dt_bg_val(c))
#define         begin_DFOUT_BG(c)        ( Dt_bg_begin(c))
#define         einde_DFOUT_BG(c)        ( Dt_bg_end(c))
#define         DFOUT_FG(c)              ( Dt_fg_val(c))
#define         begin_DFOUT_FG(c)        ( Dt_fg_begin(c))
#define         einde_DFOUT_FG(c)        ( Dt_fg_end(c))

#define         DSPEED(c)                ( Dt_speed_val(c))
#define         direction_DSPEED(c)      ( Dt_speed_direction(c))
#define         status_DSPEED(c)         ( Dt_speed_status(c))
#define         vehicle_DSPEED(c)        ( Dt_speed_vehicle(c))
#define         DLENGTH(c)               ( Dt_length_val(c))
#define         direction_DLENGTH(c)     ( Dt_length_direction(c))
#define         status_DLENGTH(c)        ( Dt_length_status(c))

#define         DA(a)                    ( Hfs_val(__DA,a))
#define         begin_DA(a)              ( Hfs_begin(__DA,a))
#define         einde_DA(a)              ( Hfs_end(__DA,a))
#define         set_DA(a)                ( Hfs_set(__DA,a))
#define         reset_DA(a)              ( Hfs_reset(__DA,a))

#define         inst_EPARM(a)            ( EPARM_val(a))
#define         wijzig_EPARM(a, v)       ( EPARM_change(a, (Int32)v))

#define         inst_EGGPARM(a)          ( EGGPARM_val(a))
#define         wijzig_EGGPARM(a, v)     ( EGGPARM_change(a, (Int32)v))

#define         G(a)                     ( Ts_val(__G,a))
#define         begin_G(a)               ( Ts_begin(__G,a))
#define         einde_G(a)               ( Ts_end(__G,a))
#define         set_G(a)                 ( Ts_set(__G,a))
#define         reset_G(a)               ( Ts_reset(__G,a))

#define         GL(a)                    ( Ts_val(__GL,a))
#define         begin_GL(a)              ( Ts_begin(__GL,a))
#define         einde_GL(a)              ( Ts_end(__GL,a))
#define         set_GL(a)                ( Ts_set(__GL,a))
#define         reset_GL(a)              ( Ts_reset(__GL,a))

#define         GG_TIJD(a)               ( Td_val(__GG_TIJD,a))
#define         begin_GG_TIJD(a)         ( Td_begin(__GG_TIJD,a))
#define         einde_GG_TIJD(a)         ( Td_end(__GG_TIJD,a))
#define         start_GG_TIJD(a)         ( Td_start(__GG_TIJD,a))
#define         herstart_GG_TIJD(a)      ( Td_herstart(__GG_TIJD,a))
#define         reset_GG_TIJD(a)         ( Td_reset(__GG_TIJD,a))
#define         halteer_GG_TIJD(a)       ( Td_haltr(__GG_TIJD,a))
#define         dehalteer_GG_TIJD(a)     ( Td_dehltr(__GG_TIJD,a))
#define         halterende_GG_TIJD(a)    ( Td_halted(__GG_TIJD,a))
#define         inst_GG_TIJD(a)          ( Td_waarde(__GG_TIJD,a))
#define         waarde_GG_TIJD(a)        ( Td_moment_waarde(__GG_TIJD,a))

#define         GGL_TIJD(a)              ( Td_val(__GGL_TIJD,a))
#define         begin_GGL_TIJD(a)        ( Td_begin(__GGL_TIJD,a))
#define         einde_GGL_TIJD(a)        ( Td_end(__GGL_TIJD,a))
#define         start_GGL_TIJD(a)        ( Td_start(__GGL_TIJD,a))
#define         herstart_GGL_TIJD(a)     ( Td_herstart(__GGL_TIJD,a))
#define         reset_GGL_TIJD(a)        ( Td_reset(__GGL_TIJD,a))
#define         halteer_GGL_TIJD(a)      ( Td_haltr(__GGL_TIJD,a))
#define         dehalteer_GGL_TIJD(a)    ( Td_dehltr(__GGL_TIJD,a))
#define         halterende_GGL_TIJD(a)   ( Td_halted(__GGL_TIJD,a))
#define         inst_GGL_TIJD(a)         ( Td_waarde(__GGL_TIJD,a))
#define         waarde_GGL_TIJD(a)       ( Td_moment_waarde(__GGL_TIJD,a))

#define         GL_TIJD(a)               ( Td_val(__GL_TIJD,a))
#define         begin_GL_TIJD(a)         ( Td_begin(__GL_TIJD,a))
#define         einde_GL_TIJD(a)         ( Td_end(__GL_TIJD,a))
#define         start_GL_TIJD(a)         ( Td_start(__GL_TIJD,a))
#define         herstart_GL_TIJD(a)      ( Td_herstart(__GL_TIJD,a))
#define         reset_GL_TIJD(a)         ( Td_reset(__GL_TIJD,a))
#define         halteer_GL_TIJD(a)       ( Td_haltr(__GL_TIJD,a))
#define         dehalteer_GL_TIJD(a)     ( Td_dehltr(__GL_TIJD,a))
#define         halterende_GL_TIJD(a)    ( Td_halted(__GL_TIJD,a))
#define         inst_GL_TIJD(a)          ( Td_waarde(__GL_TIJD,a))
#define         waarde_GL_TIJD(a)        ( Td_moment_waarde(__GL_TIJD,a))

#define         GO_TIJD(a,b)             ( Td_o_val(__GO_TIJD,a,b))
#define         begin_GO_TIJD(a,b)       ( Td_o_begin(__GO_TIJD,a,b))
#define         einde_GO_TIJD(a,b)       ( Td_o_end(__GO_TIJD,a,b))
#define         start_GO_TIJD(a,b)       ( Td_o_set(__GO_TIJD,a,b))
#define         reset_GO_TIJD(a,b)       ( Td_o_reset(__GO_TIJD,a,b))
#define         inst_GO_TIJD(a,b)        ( Td_o_waarde(__GO_TIJD,a,b))
#define         waarde_GO_TIJD(a,b)      ( Td_o_moment_waarde(__GO_TIJD,a,b))

#define         GR_TIJD(a)               ( Td_val(__GR_TIJD,a))
#define         begin_GR_TIJD(a)         ( Td_begin(__GR_TIJD,a))
#define         einde_GR_TIJD(a)         ( Td_end(__GR_TIJD,a))
#define         start_GR_TIJD(a)         ( Td_start(__GR_TIJD,a))
#define         herstart_GR_TIJD(a)      ( Td_herstart(__GR_TIJD,a))
#define         reset_GR_TIJD(a)         ( Td_reset(__GR_TIJD,a))
#define         halteer_GR_TIJD(a)       ( Td_haltr(__GR_TIJD,a))
#define         dehalteer_GR_TIJD(a)     ( Td_dehltr(__GR_TIJD,a))
#define         halterende_GR_TIJD(a)    ( Td_halted(__GR_TIJD,a))
#define         inst_GR_TIJD(a)          ( Td_waarde(__GR_TIJD,a))
#define         waarde_GR_TIJD(a)        ( Td_moment_waarde(__GR_TIJD,a))

#define         HF(c)                    ( Hf_val(c))
#define         begin_HF(c)              ( Hf_begin(c))
#define         einde_HF(c)              ( Hf_end(c))
#define         set_HF(c)                ( Hf_set(c))
#define         reset_HF(c)              ( Hf_reset(c))

#define         B_TIJD(a)                ( Dt_td_val(__BZT_TIJD,a))
#define         begin_B_TIJD(a)          ( Dt_td_begin(__BZT_TIJD,a))
#define         einde_B_TIJD(a)          ( Dt_td_end(__BZT_TIJD,a))
#define         start_B_TIJD(a)          ( Dt_td_start(__BZT_TIJD,a))
#define         herstart_B_TIJD(a)       ( Dt_td_herstart(__BZT_TIJD,a))
#define         reset_B_TIJD(a)          ( Dt_td_reset(__BZT_TIJD,a))
#define         halteer_B_TIJD(a)        ( Dt_td_haltr(__BZT_TIJD,a))
#define         dehalteer_B_TIJD(a)      ( Dt_td_dehltr(__BZT_TIJD,a))
#define         halterende_B_TIJD(a)     ( Dt_td_halted(__BZT_TIJD,a))
#define         inst_B_TIJD(a)           ( Dt_td_waarde(__BZT_TIJD,a))
#define         waarde_B_TIJD(a)         ( Dt_td_moment_waarde(__BZT_TIJD,a))
#define         wijzig_B_TIJD(a,v)       ( Dt_td2_change(__BZT_TIJD, a, (Uint32)v))

#define         H_TIJD(a)                ( Dt_td_val(__H_TIJD,a))
#define         begin_H_TIJD(a)          ( Dt_td_begin(__H_TIJD,a))
#define         einde_H_TIJD(a)          ( Dt_td_end(__H_TIJD,a))
#define         start_H_TIJD(a)          ( Dt_td_start(__H_TIJD,a))
#define         herstart_H_TIJD(a)       ( Dt_td_herstart(__H_TIJD,a))
#define         reset_H_TIJD(a)          ( Dt_td_reset(__H_TIJD,a))
#define         halteer_H_TIJD(a)        ( Dt_td_haltr(__H_TIJD,a))
#define         dehalteer_H_TIJD(a)      ( Dt_td_dehltr(__H_TIJD,a))
#define         halterende_H_TIJD(a)     ( Dt_td_halted(__H_TIJD,a))
#define         inst_H_TIJD(a)           ( Dt_td_waarde(__H_TIJD,a))
#define         inst_H_TIJD1(a)          ( Dt_td_waarde(__H_TIJD1,a))
#define         inst_H_TIJD2(a)          ( Dt_td_waarde(__H_TIJD2,a))
#define         waarde_H_TIJD(a)         ( Dt_td_moment_waarde(__H_TIJD,a))
#define         wijzig_H_TIJD(a,v)       ( Dt_td2_change(__H_TIJD, a, (Uint32)v))

#define         KL(c)                    ( Kl_val(c))
#define         begin_KL(c)              ( Kl_begin(c))
#define         einde_KL(c)              ( Kl_end(c))
#define         set_KL(c)                ( Kl_set(c))
#define         reset_KL(c)              ( Kl_reset(c))

#define         __reset_KOPPEL_in_HF(c)  ( Kp_reset_input(c))

#define         MA(a)                    ( Hfs_val(__MA,a))
#define         begin_MA(a)              ( Hfs_begin(__MA,a))
#define         einde_MA(a)              ( Hfs_end(__MA,a))
#define         set_MA(a)                ( Hfs_set(__MA,a))
#define         reset_MA(a)              ( Hfs_reset(__MA,a))

#define         MAH4(a,n)                ( Hfsb_val(__MAH4,a,n))
#define         begin_MAH4(a,n)          ( Hfsb_begin(__MAH4,a,n))
#define         einde_MAH4(a,n)          ( Hfsb_end(__MAH4,a,n))
#define         set_MAH4(a,n)            ( Hfsb_set(__MAH4,a,n))
#define         reset_MAH4(a,n)          ( Hfsb_reset(__MAH4,a,n))

#define         MAH5(a,n)                ( Hfsb_val(__MAH5,a,n))
#define         begin_MAH5(a,n)          ( Hfsb_begin(__MAH5,a,n))
#define         einde_MAH5(a,n)          ( Hfsb_end(__MAH5,a,n))
#define         set_MAH5(a,n)            ( Hfsb_set(__MAH5,a,n))
#define         reset_MAH5(a,n)          ( Hfsb_reset(__MAH5,a,n))

#define         MAH6(a,n)                ( Hfsb_val(__MAH6,a,n))
#define         begin_MAH6(a,n)          ( Hfsb_begin(__MAH6,a,n))
#define         einde_MAH6(a,n)          ( Hfsb_end(__MAH6,a,n))
#define         set_MAH6(a,n)            ( Hfsb_set(__MAH6,a,n))
#define         reset_MAH6(a,n)          ( Hfsb_reset(__MAH6,a,n))

#define         MAH7(a,n)                ( Hfsb_val(__MAH7,a,n))
#define         begin_MAH7(a,n)          ( Hfsb_begin(__MAH7,a,n))
#define         einde_MAH7(a,n)          ( Hfsb_end(__MAH7,a,n))
#define         set_MAH7(a,n)            ( Hfsb_set(__MAH7,a,n))
#define         reset_MAH7(a,n)          ( Hfsb_reset(__MAH7,a,n))

#define         MA_OP(a)                 ( Ops_val(__MA_OP,a))
#define         begin_MA_OP(a)           ( Ops_begin(__MA_OP,a))
#define         einde_MA_OP(a)           ( Ops_end(__MA_OP,a))
#define         set_MA_OP(a)             ( Ops_set(__MA_OP,a))
#define         reset_MA_OP(a)           ( Ops_reset(__MA_OP,a))

#define         MG_TIJD(a)               ( Td_val(__MG_TIJD,a))
#define         begin_MG_TIJD(a)         ( Td_begin(__MG_TIJD,a))
#define         einde_MG_TIJD(a)         ( Td_end(__MG_TIJD,a))
#define         start_MG_TIJD(a)         ( Td_start(__MG_TIJD,a))
#define         herstart_MG_TIJD(a)      ( Td_herstart(__MG_TIJD,a))
#define         reset_MG_TIJD(a)         ( Td_reset(__MG_TIJD,a))
#define         halteer_MG_TIJD(a)       ( Td_haltr(__MG_TIJD,a))
#define         dehalteer_MG_TIJD(a)     ( Td_dehltr(__MG_TIJD,a))
#define         halterende_MG_TIJD(a)    ( Td_halted(__MG_TIJD,a))
#define         inst_MG_TIJD(a)          ( Td_waarde(__MG_TIJD,a))
#define         inst_MG_TIJD1(a)         ( Td_waarde(__MG_TIJD1,a))
#define         inst_MG_TIJD2(a)         ( Td_waarde(__MG_TIJD2,a))
#define         inst_MG_TIJD3(a)         ( Td_waarde(__MG_TIJD3,a))
#define         inst_MG_TIJD4(a)         ( Td_waarde(__MG_TIJD4,a))
#define         inst_MG_TIJD5(a)         ( Td_waarde(__MG_TIJD5,a))
#define         inst_MG_TIJD6(a)         ( Td_waarde(__MG_TIJD6,a))
#define         inst_MG_TIJD7(a)         ( Td_waarde(__MG_TIJD7,a))
#define         inst_MG_TIJD8(a)         ( Td_waarde(__MG_TIJD8,a))
#define         inst_MG_TIJD9(a)         ( Td_waarde(__MG_TIJD9,a))
#define         inst_MG_TIJD10(a)        ( Td_waarde(__MG_TIJD10,a))
#define         inst_MG_TIJD11(a)        ( Td_waarde(__MG_TIJD11,a))
#define         inst_MG_TIJD12(a)        ( Td_waarde(__MG_TIJD12,a))
#define         waarde_MG_TIJD(a)        ( Td_moment_waarde(__MG_TIJD,a))
#define         wijzig_MG_TIJD(a,v)      ( Td2_change(__MG_TIJD,a, (Uint32)v))

#define         MVG(a)                   ( Ts_val(__MVG,a))
#define         begin_MVG(a)             ( Ts_begin(__MVG,a))
#define         einde_MVG(a)             ( Ts_end(__MVG,a))
#define         set_MVG(a)               ( Ts_set(__MVG,a))
#define         reset_MVG(a)             ( Ts_reset(__MVG,a))

#define         O_TIJD(a,b)              ( Td_o_val(__O_TIJD,a,b))
#define         begin_O_TIJD(a,b)        ( Td_o_begin(__O_TIJD,a,b))
#define         einde_O_TIJD(a,b)        ( Td_o_end(__O_TIJD,a,b))
#define         start_O_TIJD(a,b)        ( Td_o_set(__O_TIJD,a,b))
#define         reset_O_TIJD(a,b)        ( Td_o_reset(__O_TIJD,a,b))
#define         inst_O_TIJD(a,b)         ( Td_o_waarde(__O_TIJD,a,b))
#define         waarde_O_TIJD(a,b)       ( Td_o_moment_waarde(__O_TIJD,a,b))

#define         PG(a,b)                  ( Hfsb_val(__PG,a,b))
#define         begin_PG(a,b)            ( Hfsb_begin(__PG,a,b))
#define         einde_PG(a,b)            ( Hfsb_end(__PG,a,b))
#define         set_PG(a,b)              ( Hfsb_set(__PG,a,b))
#define         reset_PG(a,b)            ( Hfsb_reset(__PG,a,b))

#define         PPA(a,b)                 ( Hfsb_val(__PPA,a,b))
#define         begin_PPA(a,b)           ( Hfsb_begin(__PPA,a,b))
#define         einde_PPA(a,b)           ( Hfsb_end(__PPA,a,b))
#define         set_PPA(a,b)             ( Hfsb_set(__PPA,a,b))
#define         reset_PPA(a,b)           ( Hfsb_reset(__PPA,a,b))

#define         PPAH(a)                  ( Hfs_val(__PPAH,a))
#define         begin_PPAH(a)            ( Hfs_begin(__PPAH,a))
#define         einde_PPAH(a)            ( Hfs_end(__PPAH,a))
#define         set_PPAH(a)              ( Hfs_set(__PPAH,a))
#define         reset_PPAH(a)            ( Hfs_reset(__PPAH,a))

#define         PPA_OP(a,b)              ( Opsb_val(__PPA_OP,a,b))
#define         begin_PPA_OP(a,b)        ( Opsb_begin(__PPA_OP,a,b))
#define         einde_PPA_OP(a,b)        ( Opsb_end(__PPA_OP,a,b))
#define         set_PPA_OP(a,b)          ( Opsb_set(__PPA_OP,a,b))
#define         reset_PPA_OP(a,b)        ( Opsb_reset(__PPA_OP,a,b))

#define         PPB(a)                   ( Hfs_val(__PPB,a))
#define         begin_PPB(a)             ( Hfs_begin(__PPB,a))
#define         einde_PPB(a)             ( Hfs_end(__PPB,a))
#define         set_PPB(a)               ( Hfs_set(__PPB,a))
#define         reset_PPB(a)             ( Hfs_reset(__PPB,a))

#define         PPB_OP(a)                ( Ops_val(__PPB_OP,a))
#define         begin_PPB_OP(a)          ( Ops_begin(__PPB_OP,a))
#define         einde_PPB_OP(a)          ( Ops_end(__PPB_OP,a))
#define         set_PPB_OP(a)            ( Ops_set(__PPB_OP,a))
#define         reset_PPB_OP(a)          ( Ops_reset(__PPB_OP,a))

#define         PPP(a,b)                 ( Hfsb_val(__PPP,a,b))
#define         begin_PPP(a,b)           ( Hfsb_begin(__PPP,a,b))
#define         einde_PPP(a,b)           ( Hfsb_end(__PPP,a,b))
#define         set_PPP(a,b)             ( Hfsb_set(__PPP,a,b))
#define         reset_PPP(a,b)           ( Hfsb_reset(__PPP,a,b))

#define         PPP_OP(a,b)              ( Opsb_val(__PPP_OP,a,b))
#define         begin_PPP_OP(a,b)        ( Opsb_begin(__PPP_OP,a,b))
#define         einde_PPP_OP(a,b)        ( Opsb_end(__PPP_OP,a,b))
#define         set_PPP_OP(a,b)          ( Opsb_set(__PPP_OP,a,b))
#define         reset_PPP_OP(a,b)        ( Opsb_reset(__PPP_OP,a,b))

#define         PPS(a)                   ( Hfs_val(__PPS,a))
#define         begin_PPS(a)             ( Hfs_begin(__PPS,a))
#define         einde_PPS(a)             ( Hfs_end(__PPS,a))
#define         set_PPS(a)               ( Hfs_set(__PPS,a))
#define         reset_PPS(a)             ( Hfs_reset(__PPS,a))

#define         PPS_OP(a)                ( Ops_val(__PPS_OP,a))
#define         begin_PPS_OP(a)          ( Ops_begin(__PPS_OP,a))
#define         einde_PPS_OP(a)          ( Ops_end(__PPS_OP,a))
#define         set_PPS_OP(a)            ( Ops_set(__PPS_OP,a))
#define         reset_PPS_OP(a)          ( Ops_reset(__PPS_OP,a))

#define         PPV(a)                   ( Hfs_val(__PPV,a))
#define         begin_PPV(a)             ( Hfs_begin(__PPV,a))
#define         einde_PPV(a)             ( Hfs_end(__PPV,a))
#define         set_PPV(a)               ( Hfs_set(__PPV,a))
#define         reset_PPV(a)             ( Hfs_reset(__PPV,a))

#define         PPV_OP(a)                ( Ops_val(__PPV_OP,a))
#define         begin_PPV_OP(a)          ( Ops_begin(__PPV_OP,a))
#define         einde_PPV_OP(a)          ( Ops_end(__PPV_OP,a))
#define         set_PPV_OP(a)            ( Ops_set(__PPV_OP,a))
#define         reset_PPV_OP(a)          ( Ops_reset(__PPV_OP,a))

#define         PR(a,b)                  ( Hfsb_val(__PR,a,b))
#define         begin_PR(a,b)            ( Hfsb_begin(__PR,a,b))
#define         einde_PR(a,b)            ( Hfsb_end(__PR,a,b))
#define         set_PR(a,b)              ( Hfsb_set(__PR,a,b))
#define         reset_PR(a,b)            ( Hfsb_reset(__PR,a,b))

#define         R(a)                     ( Ts_val(__R,a))
#define         begin_R(a)               ( Ts_begin(__R,a))
#define         einde_R(a)               ( Ts_end(__R,a))
#define         set_R(a)                 ( Ts_set(__R,a))
#define         reset_R(a)               ( Ts_reset(__R,a))

#define         RGAH(a,n)                ( Hfsb_val(__RGAH,a,n))
#define         begin_RGAH(a,n)          ( Hfsb_begin(__RGAH,a,n))
#define         einde_RGAH(a,n)          ( Hfsb_end(__RGAH,a,n))
#define         set_RGAH(a,n)            ( Hfsb_set(__RGAH,a,n))
#define         reset_RGAH(a,n)          ( Hfsb_reset(__RGAH,a,n))

#define         ROG(a)                   ( Ts_val(__ROG,a))
#define         begin_ROG(a)             ( Ts_begin(__ROG,a))
#define         einde_ROG(a)             ( Ts_end(__ROG,a))
#define         set_ROG(a)               ( Ts_set(__ROG,a))
#define         reset_ROG(a)             ( Ts_reset(__ROG,a))

#define         RVAG2e(a)                ( Hfs_val(__RVAG2e,a))
#define         begin_RVAG2e(a)          ( Hfs_begin(__RVAG2e,a))
#define         einde_RVAG2e(a)          ( Hfs_end(__RVAG2e,a))
#define         set_RVAG2e(a)            ( Hfs_set(__RVAG2e,a))
#define         reset_RVAG2e(a)          ( Hfs_reset(__RVAG2e,a))

#define         RVAG2e_OP(a)             ( Ops_val(__RVAG2e_OP,a))
#define         begin_RVAG2e_OP(a)       ( Ops_begin(__RVAG2e_OP,a))
#define         einde_RVAG2e_OP(a)       ( Ops_end(__RVAG2e_OP,a))
#define         set_RVAG2e_OP(a)         ( Ops_set(__RVAG2e_OP,a))
#define         reset_RVAG2e_OP(a)       ( Ops_reset(__RVAG2e_OP,a))

#define         RVG(a)                   ( Ts_val(__RVG,a))
#define         begin_RVG(a)             ( Ts_begin(__RVG,a))
#define         einde_RVG(a)             ( Ts_end(__RVG,a))
#define         set_RVG(a)               ( Ts_set(__RVG,a))
#define         reset_RVG(a)             ( Ts_reset(__RVG,a))

#define         RWG_OP(a)                ( Ops_val(__RWG_OP,a))
#define         begin_RWG_OP(a)          ( Ops_begin(__RWG_OP,a))
#define         einde_RWG_OP(a)          ( Ops_end(__RWG_OP,a))
#define         set_RWG_OP(a)            ( Ops_set(__RWG_OP,a))
#define         reset_RWG_OP(a)          ( Ops_reset(__RWG_OP,a))

#define         RWR(a)                   ( Hfs_val(__RWR,a))
#define         begin_RWR(a)             ( Hfs_begin(__RWR,a))
#define         einde_RWR(a)             ( Hfs_end(__RWR,a))
#define         set_RWR(a)               ( Hfs_set(__RWR,a))
#define         reset_RWR(a)             ( Hfs_reset(__RWR,a))

#define         RWR_OP(a)                ( Ops_val(__RWR_OP,a))
#define         begin_RWR_OP(a)          ( Ops_begin(__RWR_OP,a))
#define         einde_RWR_OP(a)          ( Ops_end(__RWR_OP,a))
#define         set_RWR_OP(a)            ( Ops_set(__RWR_OP,a))
#define         reset_RWR_OP(a)          ( Ops_reset(__RWR_OP,a))

#define         SCH(c)                   ( Sch_val(c))
#define         begin_SCH(c)             ( Sch_begin(c))
#define         einde_SCH(c)             ( Sch_end(c))
#define         set_SCH(c)               ( Sch_set(c))
#define         reset_SCH(c)             ( Sch_reset(c))

#define         SR(a)                    ( Hfs_val(__SR,a))
#define         begin_SR(a)              ( Hfs_begin(__SR,a))
#define         einde_SR(a)              ( Hfs_end(__SR,a))
#define         set_SR(a)                ( Hfs_set(__SR,a))
#define         reset_SR(a)              ( Hfs_reset(__SR,a))

#define         TMVG(a)                  ( Hfs_val(__TMVG,a))
#define         begin_TMVG(a)            ( Hfs_begin(__TMVG,a))
#define         einde_TMVG(a)            ( Hfs_end(__TMVG,a))
#define         set_TMVG(a)              ( Hfs_set(__TMVG,a))
#define         reset_TMVG(a)            ( Hfs_reset(__TMVG,a))

#define         TMVG_OP(a)               ( Ops_val(__TMVG_OP,a))
#define         begin_TMVG_OP(a)         ( Ops_begin(__TMVG_OP,a))
#define         einde_TMVG_OP(a)         ( Ops_end(__TMVG_OP,a))
#define         set_TMVG_OP(a)           ( Ops_set(__TMVG_OP,a))
#define         reset_TMVG_OP(a)         ( Ops_reset(__TMVG_OP,a))

#define         TO_PRIM(a)               ( Hfs_val(__TO_PRIM,a))
#define         begin_TO_PRIM(a)         ( Hfs_begin(__TO_PRIM,a))
#define         einde_TO_PRIM(a)         ( Hfs_end(__TO_PRIM,a))
#define         set_TO_PRIM(a)           ( Hfs_set(__TO_PRIM,a))
#define         reset_TO_PRIM(a)         ( Hfs_reset(__TO_PRIM,a))

#define         TIJD(c)                  ( Tijd_val(c))
#define         begin_TIJD(c)            ( Tijd_begin(c))
#define         einde_TIJD(c)            ( Tijd_end(c))
#define         start_TIJD(c)            ( Tijd_start(c))
#define         herstart_TIJD(c)         ( Tijd_herstart(c))
#define         reset_TIJD(c)            ( Tijd_reset(c))
#define         halteer_TIJD(c)          ( Tijd_haltr(c))
#define         dehalteer_TIJD(c)        ( Tijd_dehltr(c))
#define         halterende_TIJD(c)       ( Tijd_halted(c))
#define         inst_TIJD(c)             ( Tijd_waarde(c))
#define         waarde_TIJD(c)           ( Tijd_moment_waarde(c))
#define         wijzig_TIJD(c,v)         ( Tijd_change(c, (Uint32)v))

#define         TL(c)                    ( Tl_val(c))
#define         incr_TL(c)               ( Tl_incr(c))
#define         decr_TL(c)               ( Tl_decr(c))
#define         maak_TL(c,v)             ( Tl_set(c, (Uint16)v))

#define         TR(a)                    ( Hfs_val(__TR,a))
#define         begin_TR(a)              ( Hfs_begin(__TR,a))
#define         einde_TR(a)              ( Hfs_end(__TR,a))
#define         set_TR(a)                ( Hfs_set(__TR,a))
#define         reset_TR(a)              ( Hfs_reset(__TR,a))

#define         TR_OP(a)                 ( Ops_val(__TR_OP,a))
#define         begin_TR_OP(a)           ( Ops_begin(__TR_OP,a))
#define         einde_TR_OP(a)           ( Ops_end(__TR_OP,a))
#define         set_TR_OP(a)             ( Ops_set(__TR_OP,a))
#define         reset_TR_OP(a)           ( Ops_reset(__TR_OP,a))

#define         VAA(a)                   ( Hfs_val(__VAA,a))
#define         begin_VAA(a)             ( Hfs_begin(__VAA,a))
#define         einde_VAA(a)             ( Hfs_end(__VAA,a))
#define         set_VAA(a)               ( Hfs_set(__VAA,a))
#define         reset_VAA(a)             ( Hfs_reset(__VAA,a))

#define         VAA_OP(a)                ( Ops_val(__VAA_OP,a))
#define         begin_VAA_OP(a)          ( Ops_begin(__VAA_OP,a))
#define         einde_VAA_OP(a)          ( Ops_end(__VAA_OP,a))
#define         set_VAA_OP(a)            ( Ops_set(__VAA_OP,a))
#define         reset_VAA_OP(a)          ( Ops_reset(__VAA_OP,a))

#define         VAG1e(a)                 ( Ts_val(__VAG_1e,a))
#define         begin_VAG1e(a)           ( Ts_begin(__VAG_1e,a))
#define         einde_VAG1e(a)           ( Ts_end(__VAG_1e,a))
#define         set_VAG1e(a)             ( Ts_set(__VAG_1e,a))
#define         reset_VAG1e(a)           ( Ts_reset(__VAG_1e,a))

#define         VAG2e(a)                 ( Ts_val(__VAG_2e,a))
#define         begin_VAG2e(a)           ( Ts_begin(__VAG_2e,a))
#define         einde_VAG2e(a)           ( Ts_end(__VAG_2e,a))
#define         set_VAG2e(a)             ( Ts_set(__VAG_2e,a))
#define         reset_VAG2e(a)           ( Ts_reset(__VAG_2e,a))

#define         VVAG2e(a)                ( Hfs_val(__VVAG2e,a))
#define         begin_VVAG2e(a)          ( Hfs_begin(__VVAG2e,a))
#define         einde_VVAG2e(a)          ( Hfs_end(__VVAG2e,a))
#define         set_VVAG2e(a)            ( Hfs_set(__VVAG2e,a))
#define         reset_VVAG2e(a)          ( Hfs_reset(__VVAG2e,a))

#define         VVAG2e_OP(a)             ( Ops_val(__VVAG2e_OP,a))
#define         begin_VVAG2e_OP(a)       ( Ops_begin(__VVAG2e_OP,a))
#define         einde_VVAG2e_OP(a)       ( Ops_end(__VVAG2e_OP,a))
#define         set_VVAG2e_OP(a)         ( Ops_set(__VVAG2e_OP,a))
#define         reset_VVAG2e_OP(a)       ( Ops_reset(__VVAG2e_OP,a))

#define         VG(a)                    ( Ts_val(__VG,a))
#define         begin_VG(a)              ( Ts_begin(__VG,a))
#define         einde_VG(a)              ( Ts_end(__VG,a))
#define         set_VG(a)                ( Ts_set(__VG,a))
#define         reset_VG(a)              ( Ts_reset(__VG,a))

#define         VG_TIJD(a)               ( Td_val(__VG_TIJD,a))
#define         begin_VG_TIJD(a)         ( Td_begin(__VG_TIJD,a))
#define         einde_VG_TIJD(a)         ( Td_end(__VG_TIJD,a))
#define         start_VG_TIJD(a)         ( Td_start(__VG_TIJD,a))
#define         herstart_VG_TIJD(a)      ( Td_herstart(__VG_TIJD,a))
#define         reset_VG_TIJD(a)         ( Td_reset(__VG_TIJD,a))
#define         halteer_VG_TIJD(a)       ( Td_haltr(__VG_TIJD,a))
#define         dehalteer_VG_TIJD(a)     ( Td_dehltr(__VG_TIJD,a))
#define         halterende_VG_TIJD(a)    ( Td_halted(__VG_TIJD,a))
#define         inst_VG_TIJD(a)          ( Td_waarde(__VG_TIJD,a))
#define         waarde_VG_TIJD(a)        ( Td_moment_waarde(__VG_TIJD,a))

#define         VNM(a)                   ( Hfs_val(__VNM,a))
#define         begin_VNM(a)             ( Hfs_begin(__VNM,a))
#define         einde_VNM(a)             ( Hfs_end(__VNM,a))
#define         set_VNM(a)               ( Hfs_set(__VNM,a))
#define         reset_VNM(a)             ( Hfs_reset(__VNM,a))

#define         VNMH(a)                  ( Hfs_val(__VNMH,a))
#define         begin_VNMH(a)            ( Hfs_begin(__VNMH,a))
#define         einde_VNMH(a)            ( Hfs_end(__VNMH,a))
#define         set_VNMH(a)              ( Hfs_set(__VNMH,a))
#define         reset_VNMH(a)            ( Hfs_reset(__VNMH,a))

#define         VNM_OP(a,b)              ( Opsb_val(__VNM_OP,a,b))
#define         begin_VNM_OP(a,b)        ( Opsb_begin(__VNM_OP,a,b))
#define         einde_VNM_OP(a,b)        ( Opsb_end(__VNM_OP,a,b))
#define         set_VNM_OP(a,b)          ( Opsb_set(__VNM_OP,a,b))
#define         reset_VNM_OP(a,b)        ( Opsb_reset(__VNM_OP,a,b))

#define         VMVG(a)                  ( Hfs_val(__VMVG,a))
#define         begin_VMVG(a)            ( Hfs_begin(__VMVG,a))
#define         einde_VMVG(a)            ( Hfs_end(__VMVG,a))
#define         set_VMVG(a)              ( Hfs_set(__VMVG,a))
#define         reset_VMVG(a)            ( Hfs_reset(__VMVG,a))

#define         VMVG_OP(a)               ( Ops_val(__VMVG_OP,a))
#define         begin_VMVG_OP(a)         ( Ops_begin(__VMVG_OP,a))
#define         einde_VMVG_OP(a)         ( Ops_end(__VMVG_OP,a))
#define         set_VMVG_OP(a)           ( Ops_set(__VMVG_OP,a))
#define         reset_VMVG_OP(a)         ( Ops_reset(__VMVG_OP,a))

#define         VRVG(a)                  ( Hfs_val(__VRVG,a))
#define         begin_VRVG(a)            ( Hfs_begin(__VRVG,a))
#define         einde_VRVG(a)            ( Hfs_end(__VRVG,a))
#define         set_VRVG(a)              ( Hfs_set(__VRVG,a))
#define         reset_VRVG(a)            ( Hfs_reset(__VRVG,a))

#define         VRVG_OP(a)               ( Ops_val(__VRVG_OP,a))
#define         begin_VRVG_OP(a)         ( Ops_begin(__VRVG_OP,a))
#define         einde_VRVG_OP(a)         ( Ops_end(__VRVG_OP,a))
#define         set_VRVG_OP(a)           ( Ops_set(__VRVG_OP,a))
#define         reset_VRVG_OP(a)         ( Ops_reset(__VRVG_OP,a))

#define         WG(a)                    ( Ts_val(__WG,a))
#define         begin_WG(a)              ( Ts_begin(__WG,a))
#define         einde_WG(a)              ( Ts_end(__WG,a))
#define         set_WG(a)                ( Ts_set(__WG,a))
#define         reset_WG(a)              ( Ts_reset(__WG,a))

#define         WR(a)                    ( Ts_val(__WR,a))
#define         begin_WR(a)              ( Ts_begin(__WR,a))
#define         einde_WR(a)              ( Ts_end(__WR,a))
#define         set_WR(a)                ( Ts_set(__WR,a))
#define         reset_WR(a)              ( Ts_reset(__WR,a))

/*
 * WSRH is een sg en blok onafhankelijke hulpfunctie voor
 * de gebruiker. Intern wordt WSRH als SG afh. hulpfunctie behandeld,
 * om het onderscheid tussen de standaard applicatie
 * en de user-defined applicatie te handhaven
 */
#define         WSRH                     ( Hfs_val(__WSRH,0))
#define         begin_WSRH               ( Hfs_begin(__WSRH,0))
#define         einde_WSRH               ( Hfs_end(__WSRH,0))
#define         set_WSRH                 ( Hfs_set(__WSRH,0))
#define         reset_WSRH               ( Hfs_reset(__WSRH,0))


/*------- toewijzingen ---*/
#define         set_AVR_toewijzing_D(i)         ( Dt_n_set(i,AVR))
#define         reset_AVR_toewijzing_D(i)       ( Dt_n_reset(i,AVR))
#define         set_BS_H5p_toewijzing_D(i)      ( Dt_n_set(i,BS_H5p))
#define         reset_BS_H5p_toewijzing_D(i)    ( Dt_n_reset(i,BS_H5p))
#define         set_H1e_toewijzing_D(i)         ( Dt_n_set(i,H1e))
#define         reset_H1e_toewijzing_D(i)       ( Dt_n_reset(i,H1e))
#define         set_H2e_toewijzing_D(i)         ( Dt_n_set(i,H2e))
#define         reset_H2e_toewijzing_D(i)       ( Dt_n_reset(i,H2e))
#define         set_H1e_spec_toewijzing_D(i)    ( Dt_n_set(i,H1eSpec))
#define         reset_H1e_spec_toewijzing_D(i)  ( Dt_n_reset(i,H1eSpec))
#define         set_H2e_spec_toewijzing_D(i)    ( Dt_n_set(i,H2eSpec))
#define         reset_H2e_spec_toewijzing_D(i)  ( Dt_n_reset(i,H2eSpec))
#define         set_DFU_toewijzing_D(i)         ( Dt_t_rset(i,DFU,TRUE))
#define         reset_DFU_toewijzing_D(i)       ( Dt_t_rset(i,DFU,FALSE))
#define         set_DFA_toewijzing_D(i)         ( Dt_t_rset(i,DFA,TRUE))
#define         reset_DFA_toewijzing_D(i)       ( Dt_t_rset(i,DFA,FALSE))
#define         set_KSH_toewijzing(i)           ( Kp_rset(i,TRUE))
#define         reset_KSH_toewijzing(i)         ( Kp_rset(i,FALSE))
#define         set_KSU_toewijzing(i)           ( Kp_rset(i,FALSE))
#define         reset_KSU_toewijzing(i)         ( Kp_rset(i,FALSE))


/*------- Kiesinstructies -----*/
#define         kies_H_TIJD(n)           ( Dt_kies_H(n))
#define         kies_E_H_TIJD(n)         ( Dt_kies_EH(n))

#define         kies_MG_TIJD1            ( Sg_kies_MG1)
#define         kies_MG_TIJD2            ( Sg_kies_MG2)
#define         kies_MG_TIJD3            ( Sg_kies_MG3)
#define         kies_MG_TIJD4            ( Sg_kies_MG4)
#define         kies_MG_TIJD5            ( Sg_kies_MG5)
#define         kies_MG_TIJD6            ( Sg_kies_MG6)
#define         kies_MG_TIJD7            ( Sg_kies_MG7)
#define         kies_MG_TIJD8            ( Sg_kies_MG8)
#define         kies_MG_TIJD9            ( Sg_kies_MG9)
#define         kies_MG_TIJD10           ( Sg_kies_MG10)
#define         kies_MG_TIJD11           ( Sg_kies_MG11)
#define         kies_MG_TIJD12           ( Sg_kies_MG12)


/*----- fasebewaking en fixatie -----*/
/* set en reset WB */
#define         set_FB                          set_fb
#define         reset_FB                        reset_fb
#define         FIX                             fix_bit
#define         set_WB_toewijzing               set_wb
#define         reset_WB_toewijzing             reset_wb


/*------- datum, dag, tijd en detectiebewaking -------*/
extern  Bool    datum ( Int16, Int16, Int16 );
extern  Bool    dag   ( Int16 );
extern  Bool    tijd  ( Int16, Int16 );
extern  Int16   jaarnummer  ( void );
extern  Int16   maandnummer ( void );
extern  Int16   dagnummer   ( void );


/* enkele ccie_interface zaken */
#define         plaats_in_INT(a, b)   plaats_in_interface(a, (Int16)b)

#define         haal_uit_INT(a)       (CIF_IS[(a)])
#define         nw_info_in_INT        (CIF_PARM1WIJZPB!=CIF_GEEN_PARMWIJZ || CIF_PARM2WIJZPB!=CIF_GEEN_PARMWIJZ || CIF_ISWIJZ==CIF_GESCHREVEN)
#define         W_REG_VRI             (CIF_WPS[CIF_PROG_STATUS]==CIF_STAT_REG)
#define         DAGNUMMER             (CIF_KLOK[2])
#define         MAANDNUMMER           (CIF_KLOK[1])
#define         JAARNUMMER            (CIF_KLOK[0])
#define         OMGEVINGSFACTOREN     (CIF_OMGEVING[0])
#define         is_OMGEVING_REGEN     ((CIF_OMGEVING[0] & 0x01) != 0x00000000)
#define         is_OMGEVING_MIST      ((CIF_OMGEVING[0] & 0x02) != 0x00000000)
#define         is_OMGEVING_GLADHEID  ((CIF_OMGEVING[0] & 0x04) != 0x00000000)

Bool            schrijf_MON_UBER(unsigned char c);
Bool            lees_MON_IBER(unsigned char c);


/* m.b.t. selectieve detectie */
#define         DSI_LUS	    (CIF_DSI[CIF_DSI_LUS])     /* lusnummer			                	 */
#define         DSI_VTG	    (CIF_DSI[CIF_DSI_VTG])     /* voertuigcategorie          			 */
#define         DSI_LYN	    (CIF_DSI[CIF_DSI_LYN])     /* lijnnummer               				 */
#define         DSI_WDNST   (CIF_DSI[CIF_DSI_WDNST])   /* wagendienstnummer           		 */
#define         DSI_BEDR	(CIF_DSI[CIF_DSI_BEDR])    /* bedrijfsnummer             			 */
#define         DSI_NUM	    (CIF_DSI[CIF_DSI_NUM])     /* voertuignummer             		 	 */
#define         DSI_DIR	    (CIF_DSI[CIF_DSI_DIR])     /* richtingsnummer            		 	 */
#define         DSI_STAT	(CIF_DSI[CIF_DSI_STAT])    /* voertuigstatus             			 */
#define         DSI_PRI	    (CIF_DSI[CIF_DSI_PRI])     /* prioriteitsklasse          			 */
#define         DSI_STP	    (CIF_DSI[CIF_DSI_STP])     /* stiptheidsklasse           			 */
#define         DSI_TSTP	(CIF_DSI[CIF_DSI_TSTP])    /* stiptheid [s]              			 */
#define         DSI_LEN     (CIF_DSI[CIF_DSI_LEN])     /* voertuiglengte [m]         			 */
#define         DSI_SPD	    (CIF_DSI[CIF_DSI_SPD])     /* voertuigsnelheid [m/s]       		 */
#define         DSI_LSS	    (CIF_DSI[CIF_DSI_LSS])     /* afstand tot stopstreep [m]	   	 */
#define         DSI_TSS	    (CIF_DSI[CIF_DSI_TSS])     /* passeertijd stopstreep [s]   		 */
#define         DSI_RIT 	(CIF_DSI[CIF_DSI_RIT])     /* ritnummer                				 */
#define         DSI_RITC	(CIF_DSI[CIF_DSI_RITC])    /* ritcategorie               			 */
#define         DSI_ROUT	(CIF_DSI[CIF_DSI_ROUT])    /* routenummer openbaar vervoer   	 */
#define         DSI_TYPE	(CIF_DSI[CIF_DSI_TYPE])    /* type melding			               */
#define         DSI_OVC 	(CIF_DSI[CIF_DSI_OVC])     /* codering meldpunt openbaar vervoer */
#define         DSI_XGRAD   (CIF_DSI[CIF_DSI_XGRAD])   /* breedtegraad graden        			 */
#define         DSI_XMIN	(CIF_DSI[CIF_DSI_XMIN])    /* breedtegraad minuten         		 */
#define         DSI_XSEC	(CIF_DSI[CIF_DSI_XSEC])    /* breedtegraad seconden        		 */
#define         DSI_XHSEC   (CIF_DSI[CIF_DSI_XHSEC])   /* breedtegraad honderdste seconden */
#define         DSI_YGRAD   (CIF_DSI[CIF_DSI_YGRAD])   /* lengtegraad graden         			 */
#define         DSI_YMIN	(CIF_DSI[CIF_DSI_YMIN])    /* lengtegraad minuten        			 */
#define         DSI_YSEC	(CIF_DSI[CIF_DSI_YSEC])    /* lengtegraad seconden         		 */
#define         DSI_YHSEC   (CIF_DSI[CIF_DSI_YHSEC])   /* lengtegraad honderdste seconden	 */
#define         DSI_JAAR	(CIF_DSI[CIF_DSI_JAAR])    /* jaartal                  				 */
#define         DSI_MND 	(CIF_DSI[CIF_DSI_MND])     /* maand                     			 */
#define         DSI_DAG 	(CIF_DSI[CIF_DSI_DAG])     /* dag                    					 */
#define         DSI_UUR 	(CIF_DSI[CIF_DSI_UUR])     /* uur                    					 */
#define         DSI_MIN 	(CIF_DSI[CIF_DSI_MIN])     /* minuten                  				 */
#define         DSI_SEC 	(CIF_DSI[CIF_DSI_SEC])     /* seconden                 				 */
                                               


/* dump faciliteit */
#define         voer_dump_uit         dump_trigger

/* signaalgroep status codes */
/* ------------------------- */
#define MTM_BASE          512
#define MTM_GEDOOFD       512
#define MTM_KRUIS         513
#define MTM_PIJL          514
#define MTM_INH_VRACHT    515
#define MTM_BUS           516
#define MTM_50            517
#define MTM_60            518
#define MTM_70            519
#define MTM_80            520
#define MTM_90            521

/* actualiseren beurt voor een signaalgroep                               */
extern  void    act_BEURT(Int16);
/* controle of richting n of conflictrichtingen van n gerealiseerd worden */
extern  Bool    ovg_fml_r(Int16);
extern  Bool    ovg_fml_rc(Int16);
#define         realisatie(n)           (ovg_fml_r(n))
#define         realisatie_conflict(n)  (ovg_fml_rc(n))

#endif  /* CRAPCOD_H */
