#ifndef CRAPTAB_H
#define CRAPTAB_H

/*
 * Copyright(c) 1992 RWS Dienst Verkeerkunde
 *
 * File         : craptab.h
 *
 * Description  : structure definities en symbolische namen
 *
 * History      : 18-01-90 Creation
 *                6-7-92,  aanpassing aan nieuwe interface definitie
 *                         van de commissie C van de CVN
 *
 */


#define NG                      -1.0
#define STOP                    -2
#define START_PTP_KOPPELING	-3
#define EINDE_PTP_KOPPELING	-4

#define WAAR            ((Ofunc)1)
#define TOEPASSEN       TRUE
#define AAN             TRUE
#define UIT             FALSE
#define GEEN            FALSE

#define PRIM            1
#define ALT             2
/*  #define WSGR            4  */

#define AVR             1
#define H1e             2
#define H2e             4
#define H1eSpec         8
#define H2eSpec         16
#define BS_H5p          32

#define DP               1
#define DS               1
#define DK               2
#define bij_DF_uit       4
#define DFU              4
#define bij_DF_aan       8
#define DFA              8
#define DV              16

#define KSH             TRUE
#define KSU             FALSE


/*======================================================================*
 *
 *   De dimensies
 *
 *======================================================================*
 */

struct DIMENSIES
{
  Int16   num_bk;
  Int16   num_sg;
  Int16   num_ov;
  Int16   numovi;
  Int16   numovu;
};


/*======================================================================*
 *
 *   De wachtstandrichtingen
 *
 *======================================================================*
 */

struct WS_R
{
  Int16  sg_nr;
};


/*======================================================================*
 *
 *   De blokkentabel
 *
 *======================================================================*
 */

struct BLOKKEN
{
  Int16   bk_num;
  Int16   sg_num;
  Mask16  func;
};

struct WB
{
  Int16     wachtblok;
};

/*======================================================================*
 *
 *   De conflict-matrix met de ontruimings-
 *   en garantie-ontruimingstijden, fictieve conflictmatrix en
 *   overige matrices.
 *
 *======================================================================*
 */
struct    CONFLICT
{
  Int16  van_sg;
  Int16  naar_sg;
  Float     gor_tijd;
  Float     or_tijd;
};

struct FICT_CONFLICT
{
  Int16     van_sg;
  Int16     naar_sg;
};

struct SG_BS_H5t
{
  Int16     van_sg;
  Int16     naar_sg;
};

struct SG_BS_H5ac
{
  Int16     van_sg;
  Int16     naar_sg;
};

struct SG_BS_H66
{
  Int16     van_sg;
  Int16     naar_sg;
};


/*======================================================================*
 *
 *   De signaalgroep-tijden tabel
 *
 *======================================================================*
 */

struct SG_TIJDEN
{
  Int16   sg_num;
  Float     GG_waarde;
  Float     VG_waarde;
  Float     GGL_waarde;
  Float     GL_waarde;
  Float     GR_waarde;
};

struct MG_TIJDEN
{
  Int16   sg_num;
  Float   waarde;
  Float   waarde1;
  Float   waarde2;
  Float   waarde3;
};

struct E_MG_TIJDEN
{
  Int16   sg_num;
  Float   waarde7;
  Float   waarde8;
  Float   waarde9;
};


/*======================================================================*
 *
 *   De signaalgroep-detectie tabel
 *
 *======================================================================*
 */

struct SG_DETECTIE
{
  Int16     det_num;
  Mask16    type;
  Int16     sg_num;
  Float     bezettijd;
  Float     hiaattijd;
  Float     extra_hiaattijd;
  Mask16    functie;
};

struct SG_PPAH
{
  Int16     sg_num;
  Int16     tijd_num;
};

struct SG_RGA
{
  Int16     d1_num;
  Int16     d2_num;
  Int16     dkop_num;
  Int16     sg_num;
  Int16     vlg_num;
};

struct FIETS_VOETG_R
{
  Int16     sg_nr;
};

/*======================================================================*
 *
 *   De tabel met klokken, tijden en schakelaars
 *
 *======================================================================*
 */
struct TIJDEN
{
  Int16   nr;
  Float   duur;
};

struct KLOKKEN
{
  Int16   kl;
  Float   van;
  Float   tot;
};

struct SCHAKELAAR
{
  Int16   sch_nr;
  Bool stand;
};

struct EGGPARMS
{
  Int16   eggparm;
  Int32   inst;
};

struct EPARMS
{
  Int16   eparm;
  Float   inst;
};

/*======================================================================*
 *
 *   De optie-tabel
 *
 *======================================================================*
 */


struct SG_OPTIE
{
  Int16          sg_num;
  Ofunc          waarde;
};

struct BK_OPTIE
{
  Int16          bk_num;
  Ofunc          waarde;
};

struct SG_BK_OPTIE
{
  Int16          sg_num;
  Int16          bk_num;
  Ofunc          waarde;
};

struct KOPPEL
{
  Int16          hf_num;
  Int16          ingang;
  Int16          uitgang;
  Int16          ksu_ksh;
};

struct REGELING
{
  Int16          nummer;
};

#endif  /* CRAPTAB_H */

