#ifndef CRBK_H
#define CRBK_H

/*
 * Copyright(c) 1992 RWS Dienst Verkeerkunde
 *
 * File         : crbk.h
 *
 * Description  : Macro-definities en prototypes van hulpfuncties voor blokken
 */


/*------- externe variabelen -------*/
extern  Int16   sgn_n;     /* signaalgroep nummer         */
extern  Int16   blk_m;     /* blok-nr van 't actieve blok */
extern  Int16   blk_l;     /* blok-nr                     */


/*------- prototypes -------*/
extern  void    blok_procedure(void);

extern  Bool    blk_fml_g(void);
extern  Bool    blk_fml_gg(void);
extern  Bool    blk_fml_d(void);
extern  Bool    blk_fml_e(void);
extern  Bool    blk_fml_cb(void);
extern  Bool    blk_fml_cc(void);
extern  Bool    blk_fml_cd(void);
extern  Bool    blk_fml_p(void);
extern  Bool    blk_fml_xp(void);
extern  Bool    blk_fml_v(void);
extern  Bool    blk_fml_w(void);
extern  Bool    blk_fml_ww(void);
extern  Bool    blk_fml_x(void);
extern  Bool    blk_fml_xx(void);
extern  Bool    blk_fml_y(void);
extern  Bool    blk_fml_ap(void);
extern  Bool    blk_fml_aq(void);
extern  Bool    blk_fml_ar(void);
extern  Bool    blk_fml_bp(void);
extern  Bool    blk_fml_df(void);





/*------- blok-wisseling -------*/
#define blk_g   (blk_fml_g())
#define blk_gg  (blk_fml_gg())
#define blk_d   (blk_fml_d())
#define blk_e   (blk_fml_e())
#define blk_cb  (blk_fml_cb())
#define blk_cc  (blk_fml_cc())
#define blk_cd  (blk_fml_cd())
#define blk_p   (blk_fml_p())
#define blk_v   (blk_fml_v())
#define blk_w   (blk_fml_w())
#define blk_ww  (blk_fml_ww())
#define blk_x   (blk_fml_x())
#define blk_xx  (blk_fml_xx())
#define blk_y   (blk_fml_y())
#define blk_ap  (blk_fml_ap())
#define blk_aq  (blk_fml_aq())
#define blk_ar  (blk_fml_ar())
#define blk_bp  (blk_fml_bp())
#define blk_df  (blk_fml_df())


#define blk_c   (BLOK(blk_m))
#define blk_f   (PPA_OP(sgn_n,blk_m))
#define blk_ca  (Bk_wb_akt(blk_m))
#define blk_ce  (BO_OP(blk_m))
#define blk_cf  (Hfb_val(__BS_CF,blk_m))
#define blk_h   (Bk_is_pr_sg(sgn_n,blk_m))
#define blk_o   (WR(sgn_n)&&(!PG(sgn_n,blk_m))&&(!GR_TIJD(sgn_n))&&(!TR(sgn_n)))
#define blk_q   (einde_BLOK(blk_m))
#define blk_r   (ROG(sgn_n))
#define blk_s   (PR(sgn_n,blk_l)&&(!BLOK(blk_l))&&BLOK(blk_m)&&(ROG(sgn_n)||RVG(sgn_n)||G(sgn_n)))
#define blk_xp  (blk_fml_xp())
#define blk_hh  ((!PG(sgn_n,blk_m))&&PR(sgn_n,blk_m)&&(ROG(sgn_n)||RVG(sgn_n)||G(sgn_n)))
#define blk_t   (Bk_sg_is_prm(sgn_n,blk_mb))
#define blk_ta  (Bk_sg_is_alt(sgn_n,blk_l))
#define blk_tb  ((PPS(sgn_n)) && WR(sgn_n) && !GR_TIJD(sgn_n) && !TR(sgn_n))
#define blk_tc  (SR(sgn_n))
#define blk_u   (WR(sgn_n)&&A(sgn_n)&&(!PG(sgn_n,blk_mb))&&(!GR_TIJD(sgn_n))&&(!BLOK(blk_mb))&&(!TR(sgn_n)))
#define blk_ag  (PPV(sgn_n))
#define blk_aa  (begin_PR(sgn_n,blk_mb))
#define blk_ad  (ROG(sgn_k))
#define blk_ah  (Bk_sg_is_alt(sgn_n,blk_m))
#define blk_ao  (WR(sgn_n)&&(!GR_TIJD(sgn_n))&&A(sgn_n)&&PPA(sgn_n,blk_m)&&(!TR(sgn_n)))
#define blk_as  (begin_AR(sgn_n,blk_m))
#define blk_ad  (ROG(sgn_k))
#define blk_aw  (AR(sgn_n,blk_l))
#define blk_ax  (ROG(sgn_n) && A(sgn_n) || RVG(sgn_n) || G(sgn_n))
#define blk_ay  ((!BLOK(blk_l)) && BLOK(blk_m))
#define blk_az  (Bk_sg_is_alt(sgn_n,blk_m) && PPA(sgn_n,blk_m))
#define blk_bb  ((!BLOK(blk_mb)) && !TO_PRIM(sgn_n))
#define blk_bf  (VNM_OP(sgn_n,blk_l) && BLOK(blk_m))
#define blk_bh  (((WR(sgn_n) && (!GR_TIJD(sgn_n))) || einde_GR_TIJD(sgn_n)) && VNM(sgn_n) && !begin_VNM(sgn_n))
#define blk_bo  (MVG(sgn_n))
#define blk_bq  (G(sgn_n)&&(!MVG(sgn_n))&&VNM(sgn_n)&&einde_AR(sgn_n,blk_l))
#define blk_br  ( ROG(sgn_n) && A(sgn_n) || RVG(sgn_n) || G(sgn_n) && (!GG_TIJD(sgn_n)) && (!MVG(sgn_n)))
#define blk_z   (!Hfs_val(__BS_Z,sgn_n))
#define blk_bc  (!Hfs_val(__BS_BC,sgn_n))
#define blk_bg  (!Hfs_val(__BS_BG,sgn_n))
#define blk_da  ((PPB(sgn_n)) && WR(sgn_n) && !GR_TIJD(sgn_n) && A(sgn_n) && !TR(sgn_n))
#define blk_dc  (BR(sgn_n))
#define blk_dd  (!BLOK(blk_mb) && !TO_PRIM(sgn_n))
#define blk_dh  (VNM_OP(sgn_n,blk_l))
#define blk_dj  (BLOK(blk_m) && !begin_BLOK(blk_m))

#endif  /* CRBK_H */
