#ifndef CRSG_H
#define CRSG_H

/*
 * Copyright(c) 1992 RWS Dienst Verkeerkunde
 *
 * File         : crsg.h
 *
 * Description  : Macro-definities en prototypes van hulpfuncties voor
 *                signaalgroepen. De formules staan in de basisspecificatie
 *                870101.
 *
 * History      : 15-01-90, Creation.
 *                6-7-92,  aanpassing aan nieuwe interface definitie
 *                         van de commissie C van de CVN
 *
 */


/*------- prototypes -------*/
extern  void    signaalgroep_procedure( Int16 );
extern  Bool    ovg_fml_d(Int16);
extern  Bool    ovg_fml_ak(Int16);
extern  Bool    ovg_fml_t(Int16);
extern  Bool    ovg_fml_ac(Int16);
extern  Bool    ovg_fml_ad(Int16);
extern  Bool    ovg_fml_ax(void);
extern  Bool    ovg_fml_ay(void);
extern  Bool    ovg_fml_az(void);
extern  Bool    ovg_fml_r(Int16);
extern  Bool    ovg_fml_rc(Int16);

extern  Bool    div_as(void);
extern  Bool    div_bm(Int16);
extern  Bool    div_bo(Int16);


/*------- overgangsformules -------*/
#define ov_a    (ROG(sgn_n) && A(sgn_n))
#define ov_b    (RVG(sgn_n))
#define ov_c    (BLOKKENSCHEMA_ACTIEF ? (VNM(sgn_n)||BL(sgn_n)):BL(sgn_n))
#define ov_d    (ovg_fml_d(sgn_n))
#define ov_e    (!Sg_otv_all(sgn_n))
#define ov_av   (!Sg_gotv_all(sgn_n))
#define ov_aw   (VRVG(sgn_n))
#define ov_af   (VG(sgn_n))
#define ov_ag   ((!VG_TIJD(sgn_n))||AFK(sgn_n))
#define ov_ah   (VNM(sgn_n))
#define ov_ak   (ovg_fml_ak(sgn_n))
#define ov_h    (VAG1e(sgn_n))
#define ov_j    (VAG2e(sgn_n))
#define ov_o    ((!Dtbs_h5o(sgn_n))&&(!Dtbs_val(sgn_n)))
#define ov_p    (((!H1e_loopt(sgn_n))&&(!Dtbs_val(sgn_n)))||AFK(sgn_n))
#define ov_q    (!MG_TIJD(sgn_n))
#define ov_r    (Ts_end(__VAG_1e,sgn_n))
#define ov_s    (Sg_wsr(sgn_n))
#define ov_t    (ovg_fml_t(sgn_n))
#define ov_u    (WG(sgn_n))
#define ov_v    (AFK(sgn_n))
#define ov_w    (VAG2e(sgn_n)&&(!VVAG2e(sgn_n)))
#define ov_x    (!Dtbs_h5x(sgn_n))
#define ov_y    ((!H2e_loopt(sgn_n))||AFK(sgn_n))
#define ov_z    (MVG(sgn_n)&&(!VMVG(sgn_n)))
#define ov_aa   (!GG_TIJD(sgn_n))
#define ov_ab   (TMVG(sgn_n))
#define ov_ac   (ovg_fml_ac(sgn_n))
#define ov_ad   (ovg_fml_ad(sgn_n))
#define ov_ax   (ovg_fml_ax())
#define ov_ay   (ovg_fml_ay())
#define ov_az   (ovg_fml_az())
#define ov_ae   (GL(sgn_n)&&(!GL_TIJD(sgn_n))&&(!GGL_TIJD(sgn_n)))
#define ov_ba   (MVG(sgn_n))
#define ov_bj   (RWG_OP(sgn_n))
#define ov_br   (ROG(sgn_n))
#define ov_realisatie(n) (ROG(n) || RVG(n) || G(n) && (!MVG(n)))
#define sp_sb   (WR(sgn_n))
#define sp_se   (WR(sgn_n)&&(!GR_TIJD(sgn_n))&&(!TR(sgn_n)))
#define sp_sg   (ROG(sgn_n) && !begin_ROG(sgn_n) && !A(sgn_n))
#define sp_sh   (!PPS(sgn_n))
#define sp_si   (RWR(sgn_n))
#define sp_sj   (RVAG2e(sgn_n))

/*------- diverse formules -------*/
#define dv_bb   (Sg_vfr(sgn_n))
#define dv_ap   (R(sgn_n))
#define dv_ao   (Sg_drkav(sgn_n))
#define dv_at   (Sg_detav(sgn_n))
#define dv_aq   (!GR_TIJD(sgn_n))
#define dv_ar   (BLOKKENSCHEMA_ACTIEF ? (MA_OP(sgn_n)&&(WR(sgn_n)||ROG(sgn_n))&&(!VNM(sgn_n))&&(!BL(sgn_n))) : (MA_OP(sgn_n)&&(WR(sgn_n)||ROG(sgn_n))&&(!BL(sgn_n))))
#define dv_bc   (Sg_wsr(sgn_n)&&ROG(sgn_n))
#define dv_as   (div_as())
#define dv_bm   (div_bm((sgn_n)))
#define dv_bo   (div_bo((sgn_n)))
#define dv_bt   (BA((sgn_n)))

#endif  /* CRSG_H */
