#ifndef CRSGO_H
#define CRSGO_H

/*
 * Copyright(c) 1992 RWS Dienst Verkeerkunde
 *
 * File         : crsgo.h
 *
 * Description  : functies en macro's signaalgroep object
 *                Iedere functie die als macro gedefinierd kan worden
 *                wordt ook als macro gedefinieerd.
 *
 * History      : 29-01-90 Creation
 *                6-7-92,  aanpassing aan nieuwe interface definitie
 *                         van de commissie C van de CVN
 *                30-11-95, aanpassing t.b.v. opname status interne fasecycli
 *                          in de buffers van de commissie C van de CVN
 *
 */


#include "crsgo.d"

extern  struct SG_PARM sg_parm[ MAX_GRSG ];
extern  struct SG_PTRS          sg[ MAX_SG ];


/*
 * Support formules 
 */

/*
 * Support formules en macro's voor
 * het object signaalgroep
 *
 */

#define          Beurt_val(b)     ( *(sg[(b)].b_brt) &  sg[(b)].m)
#define          Beurt_begin(b)   ( *(sg[(b)].bg_brt) & sg[(b)].m)
#define          Beurt_end(b)     ( *(sg[(b)].en_brt) & sg[(b)].m)
#define          Beurt_tracon(b)  ( *(sg[(b)].tr_brt) |= sg[(b)].m)
#define          Beurt_tracof(b)  ( *(sg[(b)].tr_brt) &=(Mask16)~(unsigned)sg[(b)].m)

#define          Hfs_val(a,b)     ( sg[(b)].b_hf[(a)]&  sg[(b)].m)
#define          Hfs_begin(a,b)   ( sg[(b)].bg_hf[(a)]& sg[(b)].m)
#define          Hfs_end(a,b)     ( sg[(b)].en_hf[(a)]& sg[(b)].m)
#define          Hfs_tracon(a,b)  ( sg[(b)].tr_hf[(a)]|= sg[(b)].m)
#define          Hfs_tracof(a,b)  ( sg[(b)].tr_hf[(a)]&=(Mask16)~(unsigned)sg[(b)].m)

#define          Ops_val(a,b)     ( sg[(b)].b_op[(a)]& sg[(b)].m)
#define          Ops_begin(a,b)   ( sg[(b)].bg_op[(a)]& sg[(b)].m)
#define          Ops_end(a,b)     ( sg[(b)].en_op[(a)]& sg[(b)].m)
#define          Ops_tracon(a,b)  ( sg[(b)].tr_op[(a)]|= sg[(b)].m)
#define          Ops_tracof(a,b)  ( sg[(b)].tr_op[(a)]&=(Mask16)~(unsigned)sg[(b)].m)

#define          Ts_val(a,b)      ( sg[(b)].b_ts[(a)]& sg[(b)].m)
#define          Ts_begin(a,b)    ( sg[(b)].bg_ts[(a)]& sg[(b)].m)
#define          Ts_end(a,b)      ( sg[(b)].en_ts[(a)]& sg[(b)].m)
#define          Ts_tracon(a,b)   ( sg[(b)].tr_ts[(a)]|= sg[(b)].m)
#define          Ts_tracof(a,b)   ( sg[(b)].tr_ts[(a)]&=(Mask16)~(unsigned)sg[(b)].m)

#define          Td_val(a,b)      ( sg[(b)].b_td[(a)]& sg[(b)].m)
#define          Td_begin(a,b)    ( sg[(b)].bg_td[(a)]& sg[(b)].m)
#define          Td_end(a,b)      ( sg[(b)].en_td[(a)]& sg[(b)].m)
#define          Td_tracon(a,b)   ( sg[(b)].tr_td[(a)]|= sg[(b)].m)
#define          Td_tracof(a,b)   ( sg[(b)].tr_td[(a)]&=(Mask16)~(unsigned)sg[(b)].m)
#define          Td_wtracon(a,b)  ( sg[(b)].tr_wtd[(a)]|= sg[(b)].m)
#define          Td_wtracof(a,b)  ( sg[(b)].tr_wtd[(a)]&=(Mask16)~(unsigned)sg[(b)].m)
#define          Td_def(a,b)      ( sg[(b)].p_t[(a)]!=NULL)           /* tijd gedefinieerd voor deze SG? */
#define          Td_halted(a,b)   ( sg[(b)].hl_td[(a)]& sg[(b)].m)  /* tijd gehalteerd ? */

/*
 * in het onderstaande dient te staan "( (a)==O_TIJD ) of (a)==__O_TIJD )
 * Beide macro's kunnen niet tegelijk aanwezig zijn, vandaar
 * deze tijdelijke oplossing.
 *
 */
#define    Td_o_val(a,b,c)        ( (a)==__O_TIJD?sg[(b)].b_ot[(c)]&sg[(b)].m:sg[(b)].b_got[(c)]&sg[(b)].m)
#define    Td_o_begin(a,b,c)      ( (a)==__O_TIJD?sg[(b)].bg_ot[(c)]&sg[(b)].m:sg[(b)].bg_got[(c)]&sg[(b)].m)
#define    Td_o_end(a,b,c)        ( (a)==__O_TIJD?sg[(b)].en_ot[(c)]&sg[(b)].m:sg[(b)].en_got[(c)]&sg[(b)].m)
#define    Td_o_tracon(a,b,c)     ( (a)==__O_TIJD?(sg[(b)].tr_ot[(c)]|=sg[(b)].m):(sg[(b)].tr_got[(c)]|=sg[(b)].m))
#define    Td_o_tracof(a,b,c)     ( (a)==__O_TIJD?(sg[(b)].tr_ot[(c)]&=(Mask16)~(unsigned)sg[(b)].m):(sg[(b)].tr_got[(c)]&=(Mask16)~(unsigned)sg[(b)].m))
#define    Td_o_def(a,b,c)        ( (a)==__O_TIJD?(sg[(b)].p_ot[(c)]!=NULL):(sg[(b)].p_got[(c)]!=NULL))

#define    Sg_vfr(a)              (*(sg[(a)].p_v) & sg[(a)].m)    /* sg is een voetgangers of (brom)fiets richting */

/*
 * macro voor wachtstandrichtingen
 *
 */
#define    Sg_wsr(a)              (*(sg[(a)].p_wsr) & sg[(a)].m)
                                  /* sg is een wachtstandrichting */

#define    Sg_drkav(a)            ( sg[(a)].b_hf[__DK]& sg[(a)].m)
                                  /* de drukknop(pen) met een aanvraag*/
                                  /* functie geeft (geven) 'n melding.*/
#define    Sg_detav(a)            ( sg[(a)].b_hf[__D]& sg[(a)].m)
                                  /* de detector(en) met een aanvraag-*/
                                  /* functie geeft (geven) 'n melding.*/
#define    Ts_get(a)              (sg[(a)].toestand)
                                  /* toestand van signaal groep       */

/* set/reset WSGR toewijzing   */
#define    Sg_set_wsr(n)          sg_parm[n/16].wsr |= (1<<(n%16))

extern  Bool    Sg_init(Int16);                         /* initialisatie */

extern  void    Beurt_set(Int16);                       /* set beurt van signaal groep   */
extern  void    Beurt_reset(Int16);                     /* reset beurt van signaal groep */

extern  void    Hfs_set(Mask16,Int16);                  /* set hulpfunctie van signaal groep   */
extern  void    Hfs_reset(Mask16,Int16);                /* reset hulpfunctie van signaal groep */

extern  void    Ops_set(Mask16,Int16);                  /* set optie van signaal groep   */
extern  void    Ops_reset(Mask16,Int16);                /* reset optie van signaal groep */

extern  void    Ts_set(Mask16,Int16);                   /* set toestand van signaal groep   */
extern  void    Ts_reset(Mask16,Int16);                 /* reset toestand van signaal groep */

extern  Uint32  Td_moment_waarde(Mask16,Int16);         /* lees momentele tijdwaarde van signaal groep uit  */
extern  Uint32  Td_o_moment_waarde(Mask16,Int16,Int16 );/* lees momentele tijdwaarde van signaal groep uit  */

extern  Uint32  Td_waarde(Mask16,Int16);                /* lees tijdwaarde van signaal groep uit  */
extern  Uint32  Td_o_waarde(Mask16,Int16,Int16 );       /* lees tijdwaarde van signaal groep uit  */

extern  void    Td_change(Mask16,Int16,Uint32);         /* verander tijdwaarde van sg samen met een "bijbehorende" tijd */
extern  void    Td2_change(Mask16,Int16,Uint32);        /* verander tijdwaarde van signaal groep */
extern  void    Td_o_change(Mask16,Int16,Int16,Uint32); /* verander tijdwaarde van signaal groep */

extern  void    Td_start(Mask16,Int16);                 /* start tijd van signaal groep          */
extern  void    Td_herstart(Mask16,Int16);              /* herstart tijd van signaal groep       */
extern  void    Td_reset(Mask16,Int16);                 /* reset tijd van signaal groep          */
extern  void    Td_haltr(Mask16,Int16);                 /* halteer tijd van signaal groep        */
extern  void    Td_dehltr(Mask16,Int16);                /* dehalteer tijd van signaal groep      */

extern  void    Td_o_set(Mask16,Int16,Int16);           /* set tijd van signaal groep   */
extern  void    Td_o_reset(Mask16,Int16,Int16);         /* reset tijd van signaal groep */

extern  void    Td_set_halt(Mask16,Int16);              /* halteer een tijd van signaal groep    */
extern  void    Td_set_door(Mask16,Int16);              /* start een tijd door van signaal groep */

extern  Bool    Sg_ts_all(Int16,Bool64);
extern  Bool    Sg_hfs_all(Int16, Bool64);
extern  Bool    Sg_ops_all(Int16, Bool64);
extern  Bool    Sg_confl_all(Int16, Bool64);
extern  Bool    Sg_fconfl_all(Int16, Bool64);
extern  Bool    Sg_bs_h5t_all(Int16, Bool64);
extern  Bool    Sg_bs_h5ac_all(Int16, Bool64);
extern  Bool    Sg_otv_all(Int16);
extern  Bool    Sg_gotv_all(Int16);
extern  Bool    Sg_output(Int16 *);
extern  void    Sg_rfsh(void);
extern  Bool    Sg_gek_sg(Int16, Bool64);
extern  Int16   Sg_num(void);

extern  void    Ops_eval(void);                    /* evalueer SG gebonden functies */
extern  void    Ops_MA_eval(void);                 /* evalueer MA_opties */

extern  void    Sg_kies_MG1(void);                 /* kies 1e MG tijden        */
extern  void    Sg_kies_MG2(void);                 /* kies 2e MG tijden        */
extern  void    Sg_kies_MG3(void);                 /* kies 3e MG tijden        */
extern  void    Sg_kies_MG4(void);                 /* kies 4e MG tijden        */
extern  void    Sg_kies_MG5(void);                 /* kies 5e MG tijden        */
extern  void    Sg_kies_MG6(void);                 /* kies 6e MG tijden        */
extern  void    Sg_kies_MG7(void);                 /* kies 7e MG tijden        */
extern  void    Sg_kies_MG8(void);                 /* kies 8e MG tijden        */
extern  void    Sg_kies_MG9(void);                 /* kies 9e MG tijden        */
extern  void    Sg_kies_MG10(void);                /* kies 10e MG tijden       */
extern  void    Sg_kies_MG11(void);                /* kies 11e MG tijden       */
extern  void    Sg_kies_MG12(void);                /* kies 12e MG tijden       */

extern  Bool    Fc_output(Int16 *);

extern  void    set_WSGR_toewijzing(Int16 n);
extern  void    reset_WSGR_toewijzing(Int16 n);
extern  Bool    Sg_all_wsr  (Bool64 sg);           /* Alle sign.gr. die een    */
                                                   /* wachtstandrichting zijn  */
extern  void    Sg_reset_wsr  (Int16 n);           /* reset WSGR toewijzing    */

#endif  /* CRSGO_H */
