#ifndef CRTMO_H
#define CRTMO_H

/*
 * Copyright(c) 1992 RWS Dienst Verkeerkunde
 *
 * File         : crtmo.h
 *
 * Description  : functies en macro's voor het timer object
 *                Iedere functie die als macro gedefinierd kan worden
 *                wordt ook als macro gedefinieerd.
 *
 * History      : 29-01-90 GW: Creation
 *                6-7-92,  aanpassing aan nieuwe interface definitie
 *                         van de commissie C van de CVN
 *
 */

#include "crtmo.d"


#define Tm_value(p)     ((p)->wachttijd)
#define Tm_change(p,v)  ((p)->wachttijd=(v))

/* prototype function declarations */
extern  Bool            Tm_init     (void);
extern  Tijdelement*    Tm_mount    (Uint32, Aktie , Int16 , Int16);
extern  Bool            Tm_start    (Tijdelement *);
extern  Bool            Tm_stop     (Tijdelement *);
extern  Uint32          Tm_lees     (Tijdelement *);
extern  Bool            Tm_door     (Tijdelement *);
extern  Bool            Tm_halt     (Tijdelement *);
extern  Bool            Tm_herstart (Tijdelement *);
extern  Bool            Tm_dismount (Tijdelement *);
extern  Int16           lees_ch (void);
extern  void            Tm_verwerk_tijden (Int32 );

extern LIJST lijst;

#endif  /* CRTMO_H */
