/*************************************************************************
*  Program Name  : FLASH (FLexit Application SHell)                      *
*========================================================================*
*                                                                        *
*  Filename      : evtdintf.h                                            *
*                                                                        *
*  Function      : Header file for interfacing the event dispatcher DLL. *
*                                                                        *
*  Date Created  : January 6, 1996                                       *
*                                                                        *
*  Version       : 1.0                                                   *
*                                                                        *
*  Author(s)     : E.E. de Vries (Ed)                                    *
*                                                                        *
*  Files used    :                                                       *
*                                                                        *
*  Date Modified : See RCS identification                                *
*                                                                        *
*  Modifications :                                                       *
*                                                                        *
*  Comments      :                                                       *
*                                                                        *
*------------------------------------------------------------------------*
*  COPYRIGHT (c) 1996 by A.N.D. Identification B.V. Rotterdam.           *
*************************************************************************/

#ifdef __cplusplus
extern "C" {
#endif


/* -------------------------------------------------------------------- */
/* TYPE DEFINITIONS                                                     */
/* -------------------------------------------------------------------- */

typedef int   (WINAPI *MSG_HDL_SET)(hdl_t hdl, mid_t id);
typedef int   (WINAPI *MSG_HDL_RLS)(mid_t id);
typedef int   (WINAPI *MSG_PUT)(mid_t from, mid_t to, st_t time,
                                cod_t code, siz_t size, void* data);
typedef int   (WINAPI *MSG_MODE)(int mode);
typedef mon_t (WINAPI *MON_SET)(mon_t mon);

typedef int   (WINAPI *ST_INIT)(st_t now, st_t gran, st_t mul);
typedef int   (WINAPI *ST_EXIT)(void);
typedef int   (WINAPI *ST_MODE)(int mode);
typedef int   (WINAPI *ST_MUL)(int mul);
typedef st_t  (WINAPI *ST_SET)(st_t now);
typedef st_t  (WINAPI *ST_GET)(st_t offset);
typedef int   (WINAPI *RT_SET)(rt_t* rt);
typedef int   (WINAPI *RT_GET)(rt_t* rt);


/*----------------------------------------------------------------------*/
/* GLOBAL FUNCTION POINTERS                                             */
/*----------------------------------------------------------------------*/

extern MSG_HDL_SET int_msg_hdl_set;
extern MSG_HDL_RLS int_msg_hdl_rls;
extern MSG_PUT     int_msg_put;
extern MSG_MODE    int_msg_mode;
extern MON_SET     int_mon_set;

extern ST_INIT     int_st_init;
extern ST_EXIT     int_st_exit;
extern ST_MUL      int_st_mul;
extern ST_MODE     int_st_mode;
extern ST_SET      int_st_set;
extern ST_GET      int_st_get;
extern RT_SET      int_rt_set;
extern RT_GET      int_rt_get;


/*----------------------------------------------------------------------*/
/* FUNCTION PROTOTYPES                                                  */
/*----------------------------------------------------------------------*/

int evtdisp_lib_init(void);    /* Initializate the event dispatcher DLL */
int evtdisp_lib_exit(void);            /* Exit the event dispatcher DLL */


/*----------------------------------------------------------------------*/
/* MACRO FUNCTIONS                                                      */
/*----------------------------------------------------------------------*/

#define msg_hdl_set(H, I)          ((int)(int_msg_hdl_set ? int_msg_hdl_set(H, I) : -1))
#define msg_hdl_rls(I)             ((int)(int_msg_hdl_rls ? int_msg_hdl_rls(I) : -1))
#define msg_put(F, TO, T, C, S, D) ((int)(int_msg_put ? int_msg_put(F, TO, T, C, S, D) : -1))
#define msg_mode(M)                ((int)(int_msg_mode ? int_msg_mode(M) : -1))
#define mon_set(M)                 ((mon_t)(int_mon_set ? int_mon_set(M) : NULL))

#define st_init(N, G, M)           ((int)(int_st_init ? int_st_init(N, G, M) : -1))
#define st_exit()                  ((int)(int_st_exit ? int_st_exit() : 0))
#define st_mode(M)                 ((int)(int_st_mode ? int_st_mode(M) : -1))
#define st_mul(M)                  ((int)(int_st_mode ? int_st_mul(M) : -1))
#define st_set(N)                  ((st_t)(int_st_set ? int_st_set(N) : 0))
#define st_get(O)                  ((st_t)(int_st_get ? int_st_get(O) : 0))
#define rt_set(R)                  ((int)(int_rt_set ? int_rt_set(R)   : -1))
#define rt_get(R)                  ((int)(int_rt_get ? int_rt_get(R) : -1))


#ifdef __cplusplus
}
#endif

