#ifndef CRBKO_D
#define CRBKO_D

/*
 * Copyright(c) 1992 RWS Dienst Verkeerkunde
 *
 * File         : crbko.d
 *
 * Description  : datastructures in het blok object
 *
 * History      : 08-02-90 Creation
 *                6-7-92,  aanpassing aan nieuwe interface definitie
 *                         van de commissie C van de CVN
 *
 */

/*
 * Deze eerste structure bevat elementen voor de blok-
 * afhankelijke hulpfuncties en blok-afhankelijke opties.
 * Ook gegevens mbt primaire en alternatieve SG's zijn hierin opgenomen.
 * alsmede wachtstandrichtingen.
 */

struct BK_BASE {
        Bool    hfb  [ MAX_HFB ];                /* hulpfuncties per blok */
        Bool    opb  [ MAX_OPB ];                /* opties per blok */
        Bool16  hfbs [ MAX_GRSG][MAX_HFBS ];     /* hulpfuncties per bk per sg */
        Bool16  opbs [ MAX_GRSG][MAX_OPBS ];     /* opties per bk per sg */
        };


struct BK_PARM {
        Int16   bk_nr;                           /* bloknummer */
        Bool    wacht_bk;                        /* wel / geen wachtblok */
        Bool16  prim[MAX_GRSG];                  /* primaire SG's */
        Bool16  alt[MAX_GRSG];                   /* alternatieve sg's */
        };


/*
 * Deze structure wordt per SG uitgegeven en bevat alleen maar pointers
 *
 */
struct SGBK_PTRS {
        /*
         * bitmasker voor selectie 1 uit 16 en
         * bitmasker voor de toestand
         *
         */
        Mask16  m;
        /*
         * pointers naar waarden uit deze ronde
         */
        Bool16* b_hfbs[MAX_BK];
        Bool16* b_opbs[MAX_BK];
        /*
         * pointers naar begin waarden uit deze ronde
         */
        Bool16* bg_hfbs[MAX_BK];
        Bool16* bg_opbs[MAX_BK];
        /*
         * pointers naar einde waarden uit deze ronde
         */
        Bool16* en_hfbs[MAX_BK];
        Bool16* en_opbs[MAX_BK];
        /*
         * pointers naar trace waarden
         */
        Bool16* tr_hfbs[MAX_BK];
        Bool16* tr_opbs[MAX_BK];
        /*
         * pointers naar booleans uit de configuratietabel
         */
        Bool16* p_prm[MAX_BK];
        Bool16* p_alt[MAX_BK];
/*        Bool16* p_wsr[MAX_BK];   */
        };

/*
 * Deze structure eenmalig uitgegeven en bevat alleen maar pointers
 *
 */
struct BK_PTRS {
        /*
         * pointers naar waarden uit deze ronde
         */
        Bool16* b_hfb[MAX_BK];
        Bool16* b_opb[MAX_BK];
        /*
         * pointers naar waarden uit de vorige ronde
         */
        Bool16* bg_hfb[MAX_BK];
        Bool16* bg_opb[MAX_BK];
        /*
         * pointers naar waarden uit de vorige ronde
         */
        Bool16* en_hfb[MAX_BK];
        Bool16* en_opb[MAX_BK];
        /*
         * pointers naar waarden uit de vorige ronde
         */
        Bool16* tr_hfb[MAX_BK];
        Bool16* tr_opb[MAX_BK];
};

#endif  /* CRBKO_D */
