#ifndef CRTMO_D
#define CRTMO_D

/*
 * Copyright(c) 1992 RWS Dienst Verkeerkunde
 *
 * File         : crtmo.d
 *
 * Description  : datastructures in het timer object
 *
 * History      : 05-02-90 Creation
 *                6-7-92,  aanpassing aan nieuwe interface definitie
 *                         van de commissie C van de CVN
 *
 */

#define VRIJ    0x01
#define LOPEND  0x02
#define HALTED  0x04

typedef struct {
        Uint32 *naam,           /* uniek volgnummer */
               *next,           /* pointer naar volgend tijdselement in de lijst, 0 als dit het laatste is */
               *prev;           /* pointer naar vorige tijdselement in de lijst, 0 als dit het eerste is */
        Uint8   status;         /* geeft aan in welke lijst hij zich bevindt */
        Uint32  looptijd,       /* relatieve looptijd tov vorige in lijst */
                this_tijd,      /* huidige absolute totale looptijd in tienden van sec */
                wachttijd;      /* algemene absolute totale looptijd in tienden van sec */
        Aktie   origin;         /* adres van de uit te voeren functie */
        Int16   arg_1,          /* argument 1 voor de uit te voeren functie */
                arg_2;          /* argument 2 voor de uit te voeren functie */
} Tijdelement;

struct time_list {
        Tijdelement    *first,  /* pointer naar het eerste tijdselement */
                       *last;   /* pointer naar het laatste tijdselement */
};

typedef struct {
        struct time_list        lopend, /* lijst met de lopende tijden */
                                halt,   /* lijst met de gehalteerde tijden */
                                vrij;   /* lijst met de gealloceerde klaarstaande tijden */
} LIJST;

#endif  /* CRTMO_D */
