/*
 * Copyright(c) 1992 RWS Dienst Verkeerkunde
 *
 * File         : ccie_int.c
 *
 * Description  : definities interface
 *
 * History      : Creation.
 *                01-10-2012,  aanpassing aan nieuwe interface definitie
 *                             van de commissie C van de CVN (versie 4.0)
 *
 */

#include <string.h>

void  ccie_int_maiden_init (void);
void  ccie_int_her_init (void);
void  fasecycl_ccie_int_maiden_init (void);
void  fasecycl_ccie_int_her_init (void);

#define   CIF_PUBLIC
#include "crtypes.h"

#include "rws_cif.inc"
#include "rws_dim2.h"
#include "cif.inc"
#include "fc_intrn.inc"

#undef    CIF_PUBLIC

#include "crapp.h"

#ifndef AUTOMAAT
  extern void init_COM_IBER(int port);
  extern void init_COM_UBER(int port);
#endif  

void  ccie_int_maiden_init (void)
{
        s_int16 i;

        memset ( CIF_GUS,    0, sizeof (CIF_GUS) );
        memset ( CIF_WUS,    0, sizeof (CIF_WUS) );
        memset ( CIF_IS,     0, sizeof (CIF_IS) );
        memset ( CIF_GPS,    0, sizeof (CIF_GPS) );
        memset ( CIF_WPS,    0, sizeof (CIF_WPS) );
        memset ( CIF_IBER,   0, sizeof (CIF_IBER) );
        memset ( CIF_UBER,   0, sizeof (CIF_UBER) );
        memset ( CIF_MON_IBER,  0, sizeof (CIF_MON_IBER) );
        memset ( CIF_MON_UBER,  0, sizeof (CIF_MON_UBER) );
        memset ( CIF_FILE_UBER, 0, sizeof (CIF_FILE_UBER) );
        memset ( CIF_KLOK,      0, sizeof (CIF_KLOK) );

        for (i=0; i<CIF_AANT_PARM1; i++)
        {
                CIF_PARM1[i] = -1;
        }
        for (i=0; i<CIF_AANT_PARM2; i++)
        {
                CIF_PARM2[i] = -1;
        }

        CIF_UBER_LEES = CIF_UBER_SCHRIJF = CIF_UBER;
        CIF_IBER_LEES = CIF_IBER_SCHRIJF = CIF_IBER;
        CIF_MON_UBER_LEES = CIF_MON_UBER_SCHRIJF = CIF_MON_UBER;
        CIF_MON_IBER_LEES = CIF_MON_IBER_SCHRIJF = CIF_MON_IBER;

        CIF_FILE_UBER_LEES = CIF_FILE_UBER_SCHRIJF = CIF_FILE_UBER;
        CIF_FILE_UBER_FILEWISSEL = NULL;
        CIF_PB_FILE_UBER_FILEWISSEL = FALSE;
        strcpy(CIF_FILE_UBER_FILEEXT, "vlg");
        CIF_FILE_UBER_STATUS = 0;

#ifndef AUTOMAAT
        /* berichtenbuffers COM-poort tbv PTP-protocol */
        init_COM_IBER(0);
        init_COM_UBER(0);
#endif

        CIF_ISWIJZ      = CIF_GELEZEN;
        CIF_WUSWIJZ     = CIF_GELEZEN;
        CIF_WPSWIJZ     = CIF_GELEZEN;
        CIF_GUSWIJZ     = CIF_GELEZEN;
        CIF_GPSWIJZ     = CIF_GELEZEN;
        CIF_PARM1WIJZPB = CIF_PARM2WIJZPB = CIF_GEEN_PARMWIJZ;
        CIF_PARM1WIJZAP = CIF_PARM2WIJZAP = CIF_GEEN_PARMWIJZ;

        for (i = 0; REGELING_tabel[i].nummer != STOP; i++)
        {
          CIF_GUS[CIF_AANT_US_FC + OVERIGE_SIGNALEN + i] = REGELING_tabel[i].nummer;
        }
}

void  ccie_int_her_init (void)
{
        s_int16 i;
        memset (CIF_GUS, 0, sizeof (CIF_GUS) );
        CIF_GUSWIJZ = CIF_GESCHREVEN;
        CIF_GPS[CIF_PROG_FOUT] = CIF_GEEN_FOUT;
        CIF_GPSWIJZ = CIF_GESCHREVEN;

        for (i = 0; REGELING_tabel[i].nummer != STOP; i++)
        {
          CIF_GUS[CIF_AANT_US_FC + OVERIGE_SIGNALEN + i] = REGELING_tabel[i].nummer;
        }
}

void  fasecycl_ccie_int_maiden_init (void)
{
        memset( CIF_RWSC_FC_INTERN,  0, sizeof(CIF_RWSC_FC_INTERN) );
        CIF_RWSC_FC_INTERNWIJZ   = 0;
}

void  fasecycl_ccie_int_her_init (void)
{
        memset( CIF_RWSC_FC_INTERN, 0, sizeof(CIF_RWSC_FC_INTERN) );
        CIF_RWSC_FC_INTERNWIJZ = 1;
}
