/*
 * Copyright(c) 1996 RWS Adviesdienst Verkeer en Vervoer
 *
 * File         : fc_intrn.inc
 *
 * Description  : aanvuling op de includefile (cif.inc) 
 *                van de commissie C van de CVN
 *
 * History      : creation
 *                02-05-1997 Toevoeging CIF_PUBLIC i.v.m. problemen
 *                           bij niet-pc compilers (versie 1.04.08)
 *                04-08-2004 Toevoeging FC_MTM
 *                           t.b.v. ondersteuning MTM-portalen
 *                okt 2009   Toevoeging COM_IBER en COM_UBER buffers
 *                           t.b.v. ondersteuning PTP-protocol
 *
 */

#if !defined(FC_INTRN_INC)
#define FC_INTRN_INC

#ifdef CIF_PUBLIC

s_int16  CIF_RWSC_FC_INTERN [CIF_AANT_US_FC];  /* CIF_RWSC_FC_INTERN[ ]-buffer       */
s_int16  CIF_RWSC_FC_INTERNWIJZ;               /* vlag CIF_RWSC_FC_INTERN[ ]-buffer gewijzigd */

s_int16  CIF_MTM [2*CIF_AANT_US_FC];           /* CIF_MTM[ ]-buffer                */
s_int16  CIF_MTMWIJZ;                          /* vlag CIF_MTM[ ]-buffer gewijzigd */


char  CIF_COM_IBER [CIF_MAX_COM_IBER];         /* CIF_COM_IBER[] buffer            */

char  *CIF_COM_IBER_LEES;                      /* pointer naar te lezen bericht    */
char  *CIF_COM_IBER_SCHRIJF;                   /* pointer naar te schrijven 
                                                  bericht                          */

char  CIF_COM_UBER [CIF_MAX_COM_UBER];         /* CIF_COM_UBER[] buffer            */

char  *CIF_COM_UBER_LEES;                      /* pointer naar te lezen bericht    */
char  *CIF_COM_UBER_SCHRIJF;                   /* pointer naar te schrijven 
                                                  bericht                          */

#else

extern s_int16  CIF_RWSC_FC_INTERN [ ];        /* CIF_RWSC_FC_INTERN[ ]-buffer  */
extern s_int16  CIF_RWSC_FC_INTERNWIJZ;        /* vlag CIF_RWSC_FC_INTERN[ ]-buffer gewijzigd */

extern s_int16  CIF_MTM [ ];                   /* CIF_MTM[ ]-buffer                */
extern s_int16  CIF_MTMWIJZ;                   /* vlag CIF_MTM[ ]-buffer gewijzigd */


extern char  CIF_COM_IBER [ ];                 /* CIF_COM_IBER[] buffer            */

extern char  *CIF_COM_IBER_LEES;               /* pointer naar te lezen bericht    */
extern char  *CIF_COM_IBER_SCHRIJF;            /* pointer naar te schrijven 
                                                  bericht                          */

extern char  CIF_COM_UBER [ ];                 /* CIF_COM_UBER[] buffer            */

extern char  *CIF_COM_UBER_LEES;               /* pointer naar te lezen bericht    */
extern char  *CIF_COM_UBER_SCHRIJF;            /* pointer naar te schrijven 
                                                  bericht                          */

#endif         /* CIF_PUBLIC */

#endif         /* FC_INTRN_INC */

