/*
 * Copyright(c) 1992 RWS Dienst Verkeerkunde
 *
 * File         : rws_cif.inc
 *
 * Description  : aanvuling op de includefile (cif.inc) 
 *                van de commissie C van de CVN
 *
 * History      : 6-7-92,  aanpassing aan nieuwe interface definitie
 *                         van de commissie C van de CVN
 *                30-11-95, aanpassing t.b.v. opname status interne fasecycli
 *                          in de buffers van de commissie C van de CVN
 *
 */

#if !defined(RWS_CIF_INC)
#define RWS_CIF_INC

#include "rws_dim.h"

#define    SGMAXMAX                CIF_AANT_US_FC  
#define    OUMAXMAX                CIF_AANT_US_OV  

#define    DTMAXMAX                CIF_AANT_IS_D   
#define    UIMAXMAX                CIF_AANT_IS_OV  

#define    OVMAXMAX                CIF_AANT_IS_D   

#define    P1_BEGIN               0
#define    P1_OR_TIJD             (P1_BEGIN)
#define    P1_GOR_TIJD            (P1_OR_TIJD  + SGMAXMAX*SGMAXMAX)
#define    P1_EINDE_GOR_TIJDEN    (P1_GOR_TIJD + SGMAXMAX*SGMAXMAX)

/* SG tijdentabel */
#define    P1_GG_TIJD             (P1_EINDE_GOR_TIJDEN )
#define    P1_VG_TIJD             (P1_GG_TIJD  + SGMAXMAX)
#define    P1_GGL_TIJD            (P1_VG_TIJD  + SGMAXMAX)
#define    P1_GL_TIJD             (P1_GGL_TIJD + SGMAXMAX)
#define    P1_GR_TIJD             (P1_GL_TIJD  + SGMAXMAX)
#define    P1_EINDE_SG_TIJDEN     (P1_GR_TIJD  + SGMAXMAX)

/* MG tijdentabel */
#define    P1_MG_TIJD             (P1_EINDE_SG_TIJDEN  )
#define    P1_MG_TIJD1            (P1_MG_TIJD  + SGMAXMAX)
#define    P1_MG_TIJD2            (P1_MG_TIJD1 + SGMAXMAX)
#define    P1_MG_TIJD3            (P1_MG_TIJD2 + SGMAXMAX)
#define    P1_MG_TIJD4            (P1_MG_TIJD3 + SGMAXMAX)
#define    P1_MG_TIJD5            (P1_MG_TIJD4 + SGMAXMAX)
#define    P1_MG_TIJD6            (P1_MG_TIJD5 + SGMAXMAX)
#define    P1_MG_TIJD7            (P1_MG_TIJD6 + SGMAXMAX)
#define    P1_MG_TIJD8            (P1_MG_TIJD7 + SGMAXMAX)
#define    P1_MG_TIJD9            (P1_MG_TIJD8 + SGMAXMAX)
#define    P1_MG_TIJD10           (P1_MG_TIJD9 + SGMAXMAX)
#define    P1_MG_TIJD11           (P1_MG_TIJD10 + SGMAXMAX)
#define    P1_MG_TIJD12           (P1_MG_TIJD11 + SGMAXMAX)
#define    P1_EINDE_MG_TIJDEN     (P1_MG_TIJD12 + SGMAXMAX)

/* tijden uit de klokkentabel */
#define    P1_KLOK_1e             (P1_EINDE_MG_TIJDEN  )
#define    P1_KLOK_2e             (P1_KLOK_1e + OVMAXMAX )
#define    P1_EINDE_KLOK          (P1_KLOK_2e + OVMAXMAX )

/* schakelaars */
#define    P1_SWITCH              (P1_EINDE_KLOK      )
#define    P1_EINDE_SWITCH        (P1_SWITCH + OVMAXMAX )

/* DT tijdentabel */
#define    P1_BZT_TIJD            (P1_EINDE_SWITCH )
#define    P1_H_TIJD              (P1_BZT_TIJD + DTMAXMAX)
#define    P1_H_TIJD1             (P1_H_TIJD + DTMAXMAX)
#define    P1_H_TIJD2             (P1_H_TIJD1  + DTMAXMAX)
#define    P1_EINDE_DT_TIJDEN     (P1_H_TIJD2 + DTMAXMAX)

/* extra parameters */
#define    P1_EPARM               (P1_EINDE_DT_TIJDEN)

/* Onderstaande defines worden niet gebruikt
#define    P1_EINDE_EPARM         (P1_EPARM + OVMAXMAX)
#define    P1_EINDE               (P1_EINDE_EPARM)
*/

/* tijden uit de tijdentabel */
#define    P2_BEGIN               0
#define    P2_TIJD                (P2_BEGIN)
#define    P2_EINDE_TIJD          (P2_TIJD + OVMAXMAX)

/* extra geheel getal parameters */
#define    P2_EGGPARM             (P2_EINDE_TIJD)

/* Onderstaande defines worden niet gebruikt
#define    P2_EINDE_EGGPARM       (P2_EGGPARM + OVMAXMAX)
#define    P2_EINDE               (P2_EINDE_EGGPARM)
*/

/* WPS contstant tbv halteren in FLEXSYT omgeving */
# define HALTEER                  1

/* tbv koppelsignalen */
#define KOPPELING                 256

/* tbv lezen en schrijven in de interface */
#define    eerste_vrije_ingang     (DTMAXMAX + 1)  /* oude naamgeving nog even handhaven */
#define    eerste_vrije_uitgang    (SGMAXMAX + 1)  /* oude naamgeving nog even handhaven */
#define    eerste_ophaal_positie   (DTMAXMAX + 1)
#define    eerste_plaats_positie   (SGMAXMAX + 1)

/* CIF_RWSC_FC_INTERN[ ] */
#define RWS_GL                  0       /* geel                   */
#define RWS_VGL                 1       /* vast geel              */
#define RWS_VAGL                2       /* va geel                */
#define RWS_WR                 10       /* wachtrood              */
#define RWS_ROG                12       /* recht op groen         */
#define RWS_RVG                14       /* rood voor groen        */
#define RWS_VG                 21       /* vast groen             */
#define RWS_VAG_1e             22       /* va groen               */
#define RWS_WG                 23       /* wachtgroen             */
#define RWS_VAG_2e             24       /* va groen               */
#define RWS_MVG                25       /* meeverlenggroen        */

/* Status gekoppelde regelingen */
#define RWS_STATUS_ONBEKEND      0
#define RWS_STATUS_NIET_REGELEN  1
#define RWS_STATUS_REGELEN       2

#endif

