/*
 * File         : rws_dim2.h
 *
 * Description  : systeemgrenzen van de RWS C-regelaar
 *
 * History      : Creation.
 *
 */
#if !defined(RWS_DIM2_H)
#define RWS_DIM2_H

#include "rws_dim.h"
#include "crapdef.h"

/* parameter buffer 1 */
#if defined(NUMEP)
  #define CIF_AANT_PARM1  (2*CIF_AANT_US_FC*CIF_AANT_US_FC + 18*CIF_AANT_US_FC + 3*MAX_HF + 4*CIF_AANT_IS_D + NUMEP)
  
  #if NUMEP > 25500
    #error Fout: NUMEP is groter dan het maximum van 25500
  #endif
#else
  #error Fout: NUMEP is niet gedefinieerd in de CRAPDEF.H file!
#endif

/* parameter buffer 2 */
#if defined(NUMEGGP)
  #define CIF_AANT_PARM2  (MAX_HF + NUMEGGP)
  #define P2_EINDE        (CIF_AANT_PARM2)
  
  #if NUMEGGP > 26000
    #error Fout: NUMEGGP is groter dan het maximum van 26000
  #endif
#else
  #error Fout: NUMEGGP is niet gedefinieerd in de CRAPDEF.H file!
#endif

#endif  /* RWS_DIM2_H */
